/**
 * The MIT License (MIT)
 *
 * Copyright (c) 2018 Erik Moqvist
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/**
 * This file was generated by cantools version 29.5.0 Tue Nov 27 07:38:10 2018.
 */

#include <string.h>

#include "multiplex_2.h"

#define ftoi(value) (*((uint32_t *)(&(value))))
#define itof(value) (*((float *)(&(value))))
#define dtoi(value) (*((uint64_t *)(&(value))))
#define itod(value) (*((double *)(&(value))))

ssize_t multiplex_2_shared_encode(
    uint8_t *dst_p,
    struct multiplex_2_shared_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->s0 << 0) & 0x0f);

    switch (src_p->s0) {

    case 1:
        dst_p[0] |= ((src_p->s1 << 4) & 0xf0);
        break;

    case 2:
        dst_p[1] |= ((src_p->s2 << 0) & 0xff);
        break;

    case 3:
        dst_p[0] |= ((src_p->s1 << 4) & 0xf0);
        dst_p[1] |= ((src_p->s2 << 0) & 0xff);
        break;

    case 4:
        dst_p[1] |= ((src_p->s2 << 0) & 0xff);
        break;

    case 5:
        dst_p[1] |= ((src_p->s2 << 0) & 0xff);
        break;

    default:
        break;
    }

    return (8);
}

int multiplex_2_shared_decode(
    struct multiplex_2_shared_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->s0 |= ((uint8_t)(src_p[0] & 0x0f) >> 0);

    if (dst_p->s0 & (1 << 3)) {
        dst_p->s0 |= 0xf0;
    }

    switch (dst_p->s0) {

    case 1:
        dst_p->s1 |= ((uint8_t)(src_p[0] & 0xf0) >> 4);

        if (dst_p->s1 & (1 << 3)) {
            dst_p->s1 |= 0xf0;
        }
        break;

    case 2:
        dst_p->s2 |= ((uint8_t)(src_p[1] & 0xff) >> 0);
        break;

    case 3:
        dst_p->s1 |= ((uint8_t)(src_p[0] & 0xf0) >> 4);

        if (dst_p->s1 & (1 << 3)) {
            dst_p->s1 |= 0xf0;
        }

        dst_p->s2 |= ((uint8_t)(src_p[1] & 0xff) >> 0);
        break;

    case 4:
        dst_p->s2 |= ((uint8_t)(src_p[1] & 0xff) >> 0);
        break;

    case 5:
        dst_p->s2 |= ((uint8_t)(src_p[1] & 0xff) >> 0);
        break;

    default:
        break;
    }

    return (0);
}

bool multiplex_2_shared_s0_is_in_range(int8_t value)
{
    return (true);
}

bool multiplex_2_shared_s1_is_in_range(int8_t value)
{
    return (true);
}

bool multiplex_2_shared_s2_is_in_range(int8_t value)
{
    return (true);
}

ssize_t multiplex_2_normal_encode(
    uint8_t *dst_p,
    struct multiplex_2_normal_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->s0 << 0) & 0x0f);

    switch (src_p->s0) {

    case 0:
        dst_p[0] |= ((src_p->s1 << 4) & 0xf0);
        break;

    case 1:
        dst_p[1] |= ((src_p->s2 << 0) & 0xff);
        break;

    default:
        break;
    }

    return (8);
}

int multiplex_2_normal_decode(
    struct multiplex_2_normal_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->s0 |= ((uint8_t)(src_p[0] & 0x0f) >> 0);

    if (dst_p->s0 & (1 << 3)) {
        dst_p->s0 |= 0xf0;
    }

    switch (dst_p->s0) {

    case 0:
        dst_p->s1 |= ((uint8_t)(src_p[0] & 0xf0) >> 4);

        if (dst_p->s1 & (1 << 3)) {
            dst_p->s1 |= 0xf0;
        }
        break;

    case 1:
        dst_p->s2 |= ((uint8_t)(src_p[1] & 0xff) >> 0);
        break;

    default:
        break;
    }

    return (0);
}

bool multiplex_2_normal_s0_is_in_range(int8_t value)
{
    return (true);
}

bool multiplex_2_normal_s1_is_in_range(int8_t value)
{
    return (true);
}

bool multiplex_2_normal_s2_is_in_range(int8_t value)
{
    return (true);
}

ssize_t multiplex_2_extended_encode(
    uint8_t *dst_p,
    struct multiplex_2_extended_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->s0 << 0) & 0x0f);
    dst_p[4] |= ((src_p->s6 << 0) & 0xff);

    switch (src_p->s0) {

    case 0:
        dst_p[0] |= ((src_p->s1 << 4) & 0xf0);

        switch (src_p->s1) {

        case 0:
            dst_p[1] |= ((src_p->s2 << 0) & 0xff);
            dst_p[2] |= ((src_p->s3 << 0) & 0xff);
            dst_p[3] |= ((src_p->s3 >> 8) & 0xff);
            break;

        case 2:
            dst_p[1] |= ((src_p->s4 << 0) & 0xff);
            dst_p[2] |= ((src_p->s4 >> 8) & 0xff);
            dst_p[3] |= ((src_p->s4 >> 16) & 0xff);
            break;

        default:
            break;
        }
        break;

    case 1:
        dst_p[0] |= ((src_p->s5 << 4) & 0xf0);
        dst_p[1] |= ((src_p->s5 >> 4) & 0xff);
        dst_p[2] |= ((src_p->s5 >> 12) & 0xff);
        dst_p[3] |= ((src_p->s5 >> 20) & 0xff);
        break;

    default:
        break;
    }

    switch (src_p->s6) {

    case 1:
        dst_p[5] |= ((src_p->s7 << 0) & 0xff);
        dst_p[6] |= ((src_p->s7 >> 8) & 0xff);
        dst_p[7] |= ((src_p->s7 >> 16) & 0xff);
        break;

    case 2:
        dst_p[5] |= ((src_p->s8 << 0) & 0xff);
        break;

    default:
        break;
    }

    return (8);
}

int multiplex_2_extended_decode(
    struct multiplex_2_extended_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->s0 |= ((uint8_t)(src_p[0] & 0x0f) >> 0);

    if (dst_p->s0 & (1 << 3)) {
        dst_p->s0 |= 0xf0;
    }

    dst_p->s6 |= ((uint8_t)(src_p[4] & 0xff) >> 0);

    switch (dst_p->s0) {

    case 0:
        dst_p->s1 |= ((uint8_t)(src_p[0] & 0xf0) >> 4);

        if (dst_p->s1 & (1 << 3)) {
            dst_p->s1 |= 0xf0;
        }

        switch (dst_p->s1) {

        case 0:
            dst_p->s2 |= ((uint8_t)(src_p[1] & 0xff) >> 0);
            dst_p->s3 |= ((uint16_t)(src_p[2] & 0xff) >> 0);
            dst_p->s3 |= ((uint16_t)(src_p[3] & 0xff) << 8);
            break;

        case 2:
            dst_p->s4 |= ((uint32_t)(src_p[1] & 0xff) >> 0);
            dst_p->s4 |= ((uint32_t)(src_p[2] & 0xff) << 8);
            dst_p->s4 |= ((uint32_t)(src_p[3] & 0xff) << 16);

            if (dst_p->s4 & (1 << 23)) {
                dst_p->s4 |= 0xff000000;
            }
            break;

        default:
            break;
        }
        break;

    case 1:
        dst_p->s5 |= ((uint32_t)(src_p[0] & 0xf0) >> 4);
        dst_p->s5 |= ((uint32_t)(src_p[1] & 0xff) << 4);
        dst_p->s5 |= ((uint32_t)(src_p[2] & 0xff) << 12);
        dst_p->s5 |= ((uint32_t)(src_p[3] & 0xff) << 20);

        if (dst_p->s5 & (1 << 27)) {
            dst_p->s5 |= 0xf0000000;
        }
        break;

    default:
        break;
    }

    switch (dst_p->s6) {

    case 1:
        dst_p->s7 |= ((uint32_t)(src_p[5] & 0xff) >> 0);
        dst_p->s7 |= ((uint32_t)(src_p[6] & 0xff) << 8);
        dst_p->s7 |= ((uint32_t)(src_p[7] & 0xff) << 16);

        if (dst_p->s7 & (1 << 23)) {
            dst_p->s7 |= 0xff000000;
        }
        break;

    case 2:
        dst_p->s8 |= ((uint8_t)(src_p[5] & 0xff) >> 0);
        break;

    default:
        break;
    }

    return (0);
}

bool multiplex_2_extended_s0_is_in_range(int8_t value)
{
    return (true);
}

bool multiplex_2_extended_s5_is_in_range(int32_t value)
{
    return (true);
}

bool multiplex_2_extended_s1_is_in_range(int8_t value)
{
    return (true);
}

bool multiplex_2_extended_s4_is_in_range(int32_t value)
{
    return (true);
}

bool multiplex_2_extended_s2_is_in_range(int8_t value)
{
    return (true);
}

bool multiplex_2_extended_s3_is_in_range(int16_t value)
{
    return (true);
}

bool multiplex_2_extended_s6_is_in_range(int8_t value)
{
    return (true);
}

bool multiplex_2_extended_s8_is_in_range(int8_t value)
{
    return (true);
}

bool multiplex_2_extended_s7_is_in_range(int32_t value)
{
    return (true);
}

ssize_t multiplex_2_extended_types_encode(
    uint8_t *dst_p,
    struct multiplex_2_extended_types_t *src_p,
    size_t size)
{
    uint32_t s10;
    uint32_t s9;

    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->s11 << 0) & 0x1f);

    switch (src_p->s11) {

    case 3:
        dst_p[1] |= ((src_p->s0 << 0) & 0x0f);

        switch (src_p->s0) {

        case 0:
            s10 = ftoi(src_p->s10);

            dst_p[2] |= ((s10 << 0) & 0xff);
            dst_p[3] |= ((s10 >> 8) & 0xff);
            dst_p[4] |= ((s10 >> 16) & 0xff);
            dst_p[5] |= ((s10 >> 24) & 0xff);
            break;

        default:
            break;
        }
        break;

    case 5:
        s9 = ftoi(src_p->s9);

        dst_p[3] |= ((s9 << 0) & 0xff);
        dst_p[4] |= ((s9 >> 8) & 0xff);
        dst_p[5] |= ((s9 >> 16) & 0xff);
        dst_p[6] |= ((s9 >> 24) & 0xff);
        break;

    default:
        break;
    }

    return (8);
}

int multiplex_2_extended_types_decode(
    struct multiplex_2_extended_types_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    uint32_t s10 = 0;
    uint32_t s9 = 0;

    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->s11 |= ((uint8_t)(src_p[0] & 0x1f) >> 0);

    switch (dst_p->s11) {

    case 3:
        dst_p->s0 |= ((uint8_t)(src_p[1] & 0x0f) >> 0);

        if (dst_p->s0 & (1 << 3)) {
            dst_p->s0 |= 0xf0;
        }

        switch (dst_p->s0) {

        case 0:
            s10 |= ((uint32_t)(src_p[2] & 0xff) >> 0);
            s10 |= ((uint32_t)(src_p[3] & 0xff) << 8);
            s10 |= ((uint32_t)(src_p[4] & 0xff) << 16);
            s10 |= ((uint32_t)(src_p[5] & 0xff) << 24);

            dst_p->s10 = itof(s10);
            break;

        default:
            break;
        }
        break;

    case 5:
        s9 |= ((uint32_t)(src_p[3] & 0xff) >> 0);
        s9 |= ((uint32_t)(src_p[4] & 0xff) << 8);
        s9 |= ((uint32_t)(src_p[5] & 0xff) << 16);
        s9 |= ((uint32_t)(src_p[6] & 0xff) << 24);

        dst_p->s9 = itof(s9);
        break;

    default:
        break;
    }

    return (0);
}

bool multiplex_2_extended_types_s11_is_in_range(uint8_t value)
{
    return ((value >= 2u) && (value <= 6u));
}

bool multiplex_2_extended_types_s0_is_in_range(int8_t value)
{
    return (true);
}

bool multiplex_2_extended_types_s10_is_in_range(float value)
{
    return ((value >= -340000000000000000000000000000000000000.0f) && (value <= 340000000000000000000000000000000000000.0f));
}

bool multiplex_2_extended_types_s9_is_in_range(float value)
{
    return ((value >= -1.34f) && (value <= 1235.0f));
}
