/**
 * The MIT License (MIT)
 *
 * Copyright (c) 2018 Erik Moqvist
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/**
 * This file was generated by cantools version 29.4.0 Mon Nov 26 08:10:20 2018.
 */

#include <string.h>

#include "vehicle.h"

#define ftoi(value) (*((uint32_t *)(&(value))))
#define itof(value) (*((float *)(&(value))))
#define dtoi(value) (*((uint64_t *)(&(value))))
#define itod(value) (*((double *)(&(value))))

ssize_t vehicle_rt_sb_ins_vel_body_axes_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_vel_body_axes_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_ins_vel_forwards << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_ins_vel_sideways << 1) & 0x02);
    dst_p[1] |= ((src_p->accuracy_ins_vel_body << 0) & 0xff);
    dst_p[2] |= ((src_p->ins_vel_forwards_2_d << 0) & 0xff);
    dst_p[3] |= ((src_p->ins_vel_forwards_2_d >> 8) & 0xff);
    dst_p[4] |= ((src_p->ins_vel_forwards_2_d >> 16) & 0xff);
    dst_p[5] |= ((src_p->ins_vel_sideways_2_d << 0) & 0xff);
    dst_p[6] |= ((src_p->ins_vel_sideways_2_d >> 8) & 0xff);
    dst_p[7] |= ((src_p->ins_vel_sideways_2_d >> 16) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_vel_body_axes_decode(
    struct vehicle_rt_sb_ins_vel_body_axes_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_ins_vel_forwards |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_ins_vel_sideways |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->accuracy_ins_vel_body |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->ins_vel_forwards_2_d |= ((uint32_t)(src_p[2] & 0xff) >> 0);
    dst_p->ins_vel_forwards_2_d |= ((uint32_t)(src_p[3] & 0xff) << 8);
    dst_p->ins_vel_forwards_2_d |= ((uint32_t)(src_p[4] & 0xff) << 16);

    if (dst_p->ins_vel_forwards_2_d & (1 << 23)) {
        dst_p->ins_vel_forwards_2_d |= 0xff000000;
    }

    dst_p->ins_vel_sideways_2_d |= ((uint32_t)(src_p[5] & 0xff) >> 0);
    dst_p->ins_vel_sideways_2_d |= ((uint32_t)(src_p[6] & 0xff) << 8);
    dst_p->ins_vel_sideways_2_d |= ((uint32_t)(src_p[7] & 0xff) << 16);

    if (dst_p->ins_vel_sideways_2_d & (1 << 23)) {
        dst_p->ins_vel_sideways_2_d |= 0xff000000;
    }

    return (0);
}

bool vehicle_rt_sb_ins_vel_body_axes_validity_ins_vel_forwards_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_vel_body_axes_validity_ins_vel_sideways_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_vel_body_axes_accuracy_ins_vel_body_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_vel_body_axes_ins_vel_forwards_2_d_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

bool vehicle_rt_sb_ins_vel_body_axes_ins_vel_sideways_2_d_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

ssize_t vehicle_rt_dl1_mk3_speed_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_speed_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_speed << 0) & 0x01);
    dst_p[1] |= ((src_p->accuracy_speed << 0) & 0xff);
    dst_p[2] |= ((src_p->speed << 0) & 0xff);
    dst_p[3] |= ((src_p->speed >> 8) & 0xff);
    dst_p[4] |= ((src_p->speed >> 16) & 0xff);
    dst_p[5] |= ((src_p->speed >> 24) & 0xff);

    return (8);
}

int vehicle_rt_dl1_mk3_speed_decode(
    struct vehicle_rt_dl1_mk3_speed_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_speed |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->accuracy_speed |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->speed |= ((uint32_t)(src_p[2] & 0xff) >> 0);
    dst_p->speed |= ((uint32_t)(src_p[3] & 0xff) << 8);
    dst_p->speed |= ((uint32_t)(src_p[4] & 0xff) << 16);
    dst_p->speed |= ((uint32_t)(src_p[5] & 0xff) << 24);

    return (0);
}

bool vehicle_rt_dl1_mk3_speed_validity_speed_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_dl1_mk3_speed_accuracy_speed_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_dl1_mk3_speed_speed_is_in_range(int32_t value)
{
    return ((value >= -2000000000) && (value <= 2000000000));
}

ssize_t vehicle_rt_dl1_mk3_gps_time_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_gps_time_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_gps_time << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_gps_week << 1) & 0x02);
    dst_p[1] |= ((src_p->accuracy_gps_time << 0) & 0xff);
    dst_p[2] |= ((src_p->gps_time << 0) & 0xff);
    dst_p[3] |= ((src_p->gps_time >> 8) & 0xff);
    dst_p[4] |= ((src_p->gps_time >> 16) & 0xff);
    dst_p[5] |= ((src_p->gps_time >> 24) & 0xff);
    dst_p[6] |= ((src_p->gps_week << 0) & 0xff);
    dst_p[7] |= ((src_p->gps_week >> 8) & 0xff);

    return (8);
}

int vehicle_rt_dl1_mk3_gps_time_decode(
    struct vehicle_rt_dl1_mk3_gps_time_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_gps_time |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_gps_week |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->accuracy_gps_time |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->gps_time |= ((uint32_t)(src_p[2] & 0xff) >> 0);
    dst_p->gps_time |= ((uint32_t)(src_p[3] & 0xff) << 8);
    dst_p->gps_time |= ((uint32_t)(src_p[4] & 0xff) << 16);
    dst_p->gps_time |= ((uint32_t)(src_p[5] & 0xff) << 24);
    dst_p->gps_week |= ((uint16_t)(src_p[6] & 0xff) >> 0);
    dst_p->gps_week |= ((uint16_t)(src_p[7] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_gps_time_validity_gps_time_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_dl1_mk3_gps_time_validity_gps_week_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_dl1_mk3_gps_time_accuracy_gps_time_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_dl1_mk3_gps_time_gps_time_is_in_range(uint32_t value)
{
    return (value <= 604800000u);
}

bool vehicle_rt_dl1_mk3_gps_time_gps_week_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_gps_pos_llh_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_gps_pos_llh_2_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->gps_pos_llh_longitude << 0) & 0xff);
    dst_p[1] |= ((src_p->gps_pos_llh_longitude >> 8) & 0xff);
    dst_p[2] |= ((src_p->gps_pos_llh_longitude >> 16) & 0xff);
    dst_p[3] |= ((src_p->gps_pos_llh_longitude >> 24) & 0xff);
    dst_p[4] |= ((src_p->gps_pos_llh_altitude << 0) & 0xff);
    dst_p[5] |= ((src_p->gps_pos_llh_altitude >> 8) & 0xff);
    dst_p[6] |= ((src_p->gps_pos_llh_altitude >> 16) & 0xff);
    dst_p[7] |= ((src_p->gps_pos_llh_altitude >> 24) & 0xff);

    return (8);
}

int vehicle_rt_dl1_mk3_gps_pos_llh_2_decode(
    struct vehicle_rt_dl1_mk3_gps_pos_llh_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->gps_pos_llh_longitude |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->gps_pos_llh_longitude |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->gps_pos_llh_longitude |= ((uint32_t)(src_p[2] & 0xff) << 16);
    dst_p->gps_pos_llh_longitude |= ((uint32_t)(src_p[3] & 0xff) << 24);
    dst_p->gps_pos_llh_altitude |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->gps_pos_llh_altitude |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->gps_pos_llh_altitude |= ((uint32_t)(src_p[6] & 0xff) << 16);
    dst_p->gps_pos_llh_altitude |= ((uint32_t)(src_p[7] & 0xff) << 24);

    return (0);
}

bool vehicle_rt_dl1_mk3_gps_pos_llh_2_gps_pos_llh_longitude_is_in_range(int32_t value)
{
    return ((value >= -1800000000) && (value <= 1800000000));
}

bool vehicle_rt_dl1_mk3_gps_pos_llh_2_gps_pos_llh_altitude_is_in_range(int32_t value)
{
    return ((value >= -1000000) && (value <= 100000000));
}

ssize_t vehicle_rt_dl1_mk3_gps_pos_llh_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_gps_pos_llh_1_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_gps_pos_llh_latitude << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_gps_pos_llh_longitude << 1) & 0x02);
    dst_p[0] |= ((src_p->validity_gps_pos_llh_altitude << 2) & 0x04);
    dst_p[1] |= ((src_p->accuracy_gps_pos_llh_latitude << 0) & 0xff);
    dst_p[2] |= ((src_p->accuracy_gps_pos_llh_longitude << 0) & 0xff);
    dst_p[3] |= ((src_p->accuracy_gps_pos_llh_altitude << 0) & 0xff);
    dst_p[4] |= ((src_p->gps_pos_llh_latitude << 0) & 0xff);
    dst_p[5] |= ((src_p->gps_pos_llh_latitude >> 8) & 0xff);
    dst_p[6] |= ((src_p->gps_pos_llh_latitude >> 16) & 0xff);
    dst_p[7] |= ((src_p->gps_pos_llh_latitude >> 24) & 0xff);

    return (8);
}

int vehicle_rt_dl1_mk3_gps_pos_llh_1_decode(
    struct vehicle_rt_dl1_mk3_gps_pos_llh_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_gps_pos_llh_latitude |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_gps_pos_llh_longitude |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->validity_gps_pos_llh_altitude |= ((uint8_t)(src_p[0] & 0x04) >> 2);
    dst_p->accuracy_gps_pos_llh_latitude |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->accuracy_gps_pos_llh_longitude |= ((uint8_t)(src_p[2] & 0xff) >> 0);
    dst_p->accuracy_gps_pos_llh_altitude |= ((uint8_t)(src_p[3] & 0xff) >> 0);
    dst_p->gps_pos_llh_latitude |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->gps_pos_llh_latitude |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->gps_pos_llh_latitude |= ((uint32_t)(src_p[6] & 0xff) << 16);
    dst_p->gps_pos_llh_latitude |= ((uint32_t)(src_p[7] & 0xff) << 24);

    return (0);
}

bool vehicle_rt_dl1_mk3_gps_pos_llh_1_validity_gps_pos_llh_latitude_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_dl1_mk3_gps_pos_llh_1_validity_gps_pos_llh_longitude_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_dl1_mk3_gps_pos_llh_1_validity_gps_pos_llh_altitude_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_dl1_mk3_gps_pos_llh_1_accuracy_gps_pos_llh_latitude_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_dl1_mk3_gps_pos_llh_1_accuracy_gps_pos_llh_longitude_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_dl1_mk3_gps_pos_llh_1_accuracy_gps_pos_llh_altitude_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_dl1_mk3_gps_pos_llh_1_gps_pos_llh_latitude_is_in_range(int32_t value)
{
    return ((value >= -900000000) && (value <= 900000000));
}

ssize_t vehicle_rt_dl1_mk3_gps_speed_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_gps_speed_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_gps_speed_2_d << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_gps_speed_3_d << 1) & 0x02);
    dst_p[1] |= ((src_p->accuracy_gps_speed << 0) & 0xff);
    dst_p[2] |= ((src_p->gps_speed_2_d << 0) & 0xff);
    dst_p[3] |= ((src_p->gps_speed_2_d >> 8) & 0xff);
    dst_p[4] |= ((src_p->gps_speed_2_d >> 16) & 0xff);
    dst_p[5] |= ((src_p->gps_speed_3_d << 0) & 0xff);
    dst_p[6] |= ((src_p->gps_speed_3_d >> 8) & 0xff);
    dst_p[7] |= ((src_p->gps_speed_3_d >> 16) & 0xff);

    return (8);
}

int vehicle_rt_dl1_mk3_gps_speed_decode(
    struct vehicle_rt_dl1_mk3_gps_speed_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_gps_speed_2_d |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_gps_speed_3_d |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->accuracy_gps_speed |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->gps_speed_2_d |= ((uint32_t)(src_p[2] & 0xff) >> 0);
    dst_p->gps_speed_2_d |= ((uint32_t)(src_p[3] & 0xff) << 8);
    dst_p->gps_speed_2_d |= ((uint32_t)(src_p[4] & 0xff) << 16);
    dst_p->gps_speed_3_d |= ((uint32_t)(src_p[5] & 0xff) >> 0);
    dst_p->gps_speed_3_d |= ((uint32_t)(src_p[6] & 0xff) << 8);
    dst_p->gps_speed_3_d |= ((uint32_t)(src_p[7] & 0xff) << 16);

    return (0);
}

bool vehicle_rt_dl1_mk3_gps_speed_validity_gps_speed_2_d_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_dl1_mk3_gps_speed_validity_gps_speed_3_d_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_dl1_mk3_gps_speed_accuracy_gps_speed_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_dl1_mk3_gps_speed_gps_speed_2_d_is_in_range(uint32_t value)
{
    return (value <= 16750000u);
}

bool vehicle_rt_dl1_mk3_gps_speed_gps_speed_3_d_is_in_range(uint32_t value)
{
    return (value <= 16750000u);
}

ssize_t vehicle_rt_ir_temp_temp_7_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_7_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_7 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_7 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_7_decode(
    struct vehicle_rt_ir_temp_temp_7_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_7 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_7 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_7_ir_temperature_7_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_rr_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_rr_2_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->ir_temperature_29 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_29 >> 8) & 0xff);
    dst_p[2] |= ((src_p->ir_temperature_30 << 0) & 0xff);
    dst_p[3] |= ((src_p->ir_temperature_30 >> 8) & 0xff);
    dst_p[4] |= ((src_p->ir_temperature_31 << 0) & 0xff);
    dst_p[5] |= ((src_p->ir_temperature_31 >> 8) & 0xff);
    dst_p[6] |= ((src_p->ir_temperature_32 << 0) & 0xff);
    dst_p[7] |= ((src_p->ir_temperature_32 >> 8) & 0xff);

    return (8);
}

int vehicle_rt_ir_temp_temp_rr_2_decode(
    struct vehicle_rt_ir_temp_temp_rr_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_29 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_29 |= ((uint16_t)(src_p[1] & 0xff) << 8);
    dst_p->ir_temperature_30 |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->ir_temperature_30 |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->ir_temperature_31 |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->ir_temperature_31 |= ((uint16_t)(src_p[5] & 0xff) << 8);
    dst_p->ir_temperature_32 |= ((uint16_t)(src_p[6] & 0xff) >> 0);
    dst_p->ir_temperature_32 |= ((uint16_t)(src_p[7] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_rr_2_ir_temperature_29_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_rr_2_ir_temperature_30_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_rr_2_ir_temperature_31_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_rr_2_ir_temperature_32_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_rl_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_rl_2_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->ir_temperature_21 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_21 >> 8) & 0xff);
    dst_p[2] |= ((src_p->ir_temperature_22 << 0) & 0xff);
    dst_p[3] |= ((src_p->ir_temperature_22 >> 8) & 0xff);
    dst_p[4] |= ((src_p->ir_temperature_23 << 0) & 0xff);
    dst_p[5] |= ((src_p->ir_temperature_23 >> 8) & 0xff);
    dst_p[6] |= ((src_p->ir_temperature_24 << 0) & 0xff);
    dst_p[7] |= ((src_p->ir_temperature_24 >> 8) & 0xff);

    return (8);
}

int vehicle_rt_ir_temp_temp_rl_2_decode(
    struct vehicle_rt_ir_temp_temp_rl_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_21 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_21 |= ((uint16_t)(src_p[1] & 0xff) << 8);
    dst_p->ir_temperature_22 |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->ir_temperature_22 |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->ir_temperature_23 |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->ir_temperature_23 |= ((uint16_t)(src_p[5] & 0xff) << 8);
    dst_p->ir_temperature_24 |= ((uint16_t)(src_p[6] & 0xff) >> 0);
    dst_p->ir_temperature_24 |= ((uint16_t)(src_p[7] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_rl_2_ir_temperature_21_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_rl_2_ir_temperature_22_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_rl_2_ir_temperature_23_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_rl_2_ir_temperature_24_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_fr_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_fr_2_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->ir_temperature_13 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_13 >> 8) & 0xff);
    dst_p[2] |= ((src_p->ir_temperature_14 << 0) & 0xff);
    dst_p[3] |= ((src_p->ir_temperature_14 >> 8) & 0xff);
    dst_p[4] |= ((src_p->ir_temperature_15 << 0) & 0xff);
    dst_p[5] |= ((src_p->ir_temperature_15 >> 8) & 0xff);
    dst_p[6] |= ((src_p->ir_temperature_16 << 0) & 0xff);
    dst_p[7] |= ((src_p->ir_temperature_16 >> 8) & 0xff);

    return (8);
}

int vehicle_rt_ir_temp_temp_fr_2_decode(
    struct vehicle_rt_ir_temp_temp_fr_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_13 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_13 |= ((uint16_t)(src_p[1] & 0xff) << 8);
    dst_p->ir_temperature_14 |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->ir_temperature_14 |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->ir_temperature_15 |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->ir_temperature_15 |= ((uint16_t)(src_p[5] & 0xff) << 8);
    dst_p->ir_temperature_16 |= ((uint16_t)(src_p[6] & 0xff) >> 0);
    dst_p->ir_temperature_16 |= ((uint16_t)(src_p[7] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_fr_2_ir_temperature_13_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_fr_2_ir_temperature_14_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_fr_2_ir_temperature_15_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_fr_2_ir_temperature_16_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_fl_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_fl_2_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->ir_temperature_5 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_5 >> 8) & 0xff);
    dst_p[2] |= ((src_p->ir_temperature_6 << 0) & 0xff);
    dst_p[3] |= ((src_p->ir_temperature_6 >> 8) & 0xff);
    dst_p[4] |= ((src_p->ir_temperature_7 << 0) & 0xff);
    dst_p[5] |= ((src_p->ir_temperature_7 >> 8) & 0xff);
    dst_p[6] |= ((src_p->ir_temperature_8 << 0) & 0xff);
    dst_p[7] |= ((src_p->ir_temperature_8 >> 8) & 0xff);

    return (8);
}

int vehicle_rt_ir_temp_temp_fl_2_decode(
    struct vehicle_rt_ir_temp_temp_fl_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_5 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_5 |= ((uint16_t)(src_p[1] & 0xff) << 8);
    dst_p->ir_temperature_6 |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->ir_temperature_6 |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->ir_temperature_7 |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->ir_temperature_7 |= ((uint16_t)(src_p[5] & 0xff) << 8);
    dst_p->ir_temperature_8 |= ((uint16_t)(src_p[6] & 0xff) >> 0);
    dst_p->ir_temperature_8 |= ((uint16_t)(src_p[7] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_fl_2_ir_temperature_5_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_fl_2_ir_temperature_6_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_fl_2_ir_temperature_7_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_fl_2_ir_temperature_8_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_rr_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_rr_1_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->ir_temperature_25 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_25 >> 8) & 0xff);
    dst_p[2] |= ((src_p->ir_temperature_26 << 0) & 0xff);
    dst_p[3] |= ((src_p->ir_temperature_26 >> 8) & 0xff);
    dst_p[4] |= ((src_p->ir_temperature_27 << 0) & 0xff);
    dst_p[5] |= ((src_p->ir_temperature_27 >> 8) & 0xff);
    dst_p[6] |= ((src_p->ir_temperature_28 << 0) & 0xff);
    dst_p[7] |= ((src_p->ir_temperature_28 >> 8) & 0xff);

    return (8);
}

int vehicle_rt_ir_temp_temp_rr_1_decode(
    struct vehicle_rt_ir_temp_temp_rr_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_25 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_25 |= ((uint16_t)(src_p[1] & 0xff) << 8);
    dst_p->ir_temperature_26 |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->ir_temperature_26 |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->ir_temperature_27 |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->ir_temperature_27 |= ((uint16_t)(src_p[5] & 0xff) << 8);
    dst_p->ir_temperature_28 |= ((uint16_t)(src_p[6] & 0xff) >> 0);
    dst_p->ir_temperature_28 |= ((uint16_t)(src_p[7] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_rr_1_ir_temperature_25_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_rr_1_ir_temperature_26_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_rr_1_ir_temperature_27_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_rr_1_ir_temperature_28_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_rl_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_rl_1_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->ir_temperature_17 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_17 >> 8) & 0xff);
    dst_p[2] |= ((src_p->ir_temperature_18 << 0) & 0xff);
    dst_p[3] |= ((src_p->ir_temperature_18 >> 8) & 0xff);
    dst_p[4] |= ((src_p->ir_temperature_19 << 0) & 0xff);
    dst_p[5] |= ((src_p->ir_temperature_19 >> 8) & 0xff);
    dst_p[6] |= ((src_p->ir_temperature_20 << 0) & 0xff);
    dst_p[7] |= ((src_p->ir_temperature_20 >> 8) & 0xff);

    return (8);
}

int vehicle_rt_ir_temp_temp_rl_1_decode(
    struct vehicle_rt_ir_temp_temp_rl_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_17 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_17 |= ((uint16_t)(src_p[1] & 0xff) << 8);
    dst_p->ir_temperature_18 |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->ir_temperature_18 |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->ir_temperature_19 |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->ir_temperature_19 |= ((uint16_t)(src_p[5] & 0xff) << 8);
    dst_p->ir_temperature_20 |= ((uint16_t)(src_p[6] & 0xff) >> 0);
    dst_p->ir_temperature_20 |= ((uint16_t)(src_p[7] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_rl_1_ir_temperature_17_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_rl_1_ir_temperature_18_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_rl_1_ir_temperature_19_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_rl_1_ir_temperature_20_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_fr_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_fr_1_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->ir_temperature_9 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_9 >> 8) & 0xff);
    dst_p[2] |= ((src_p->ir_temperature_10 << 0) & 0xff);
    dst_p[3] |= ((src_p->ir_temperature_10 >> 8) & 0xff);
    dst_p[4] |= ((src_p->ir_temperature_11 << 0) & 0xff);
    dst_p[5] |= ((src_p->ir_temperature_11 >> 8) & 0xff);
    dst_p[6] |= ((src_p->ir_temperature_12 << 0) & 0xff);
    dst_p[7] |= ((src_p->ir_temperature_12 >> 8) & 0xff);

    return (8);
}

int vehicle_rt_ir_temp_temp_fr_1_decode(
    struct vehicle_rt_ir_temp_temp_fr_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_9 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_9 |= ((uint16_t)(src_p[1] & 0xff) << 8);
    dst_p->ir_temperature_10 |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->ir_temperature_10 |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->ir_temperature_11 |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->ir_temperature_11 |= ((uint16_t)(src_p[5] & 0xff) << 8);
    dst_p->ir_temperature_12 |= ((uint16_t)(src_p[6] & 0xff) >> 0);
    dst_p->ir_temperature_12 |= ((uint16_t)(src_p[7] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_fr_1_ir_temperature_9_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_fr_1_ir_temperature_10_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_fr_1_ir_temperature_11_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_fr_1_ir_temperature_12_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_fl_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_fl_1_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->ir_temperature_1 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_1 >> 8) & 0xff);
    dst_p[2] |= ((src_p->ir_temperature_2 << 0) & 0xff);
    dst_p[3] |= ((src_p->ir_temperature_2 >> 8) & 0xff);
    dst_p[4] |= ((src_p->ir_temperature_3 << 0) & 0xff);
    dst_p[5] |= ((src_p->ir_temperature_3 >> 8) & 0xff);
    dst_p[6] |= ((src_p->ir_temperature_4 << 0) & 0xff);
    dst_p[7] |= ((src_p->ir_temperature_4 >> 8) & 0xff);

    return (8);
}

int vehicle_rt_ir_temp_temp_fl_1_decode(
    struct vehicle_rt_ir_temp_temp_fl_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_1 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_1 |= ((uint16_t)(src_p[1] & 0xff) << 8);
    dst_p->ir_temperature_2 |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->ir_temperature_2 |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->ir_temperature_3 |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->ir_temperature_3 |= ((uint16_t)(src_p[5] & 0xff) << 8);
    dst_p->ir_temperature_4 |= ((uint16_t)(src_p[6] & 0xff) >> 0);
    dst_p->ir_temperature_4 |= ((uint16_t)(src_p[7] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_fl_1_ir_temperature_1_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_fl_1_ir_temperature_2_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_fl_1_ir_temperature_3_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_ir_temp_temp_fl_1_ir_temperature_4_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_32_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_32_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_32 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_32 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_32_decode(
    struct vehicle_rt_ir_temp_temp_32_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_32 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_32 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_32_ir_temperature_32_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_31_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_31_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_31 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_31 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_31_decode(
    struct vehicle_rt_ir_temp_temp_31_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_31 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_31 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_31_ir_temperature_31_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_30_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_30_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_30 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_30 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_30_decode(
    struct vehicle_rt_ir_temp_temp_30_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_30 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_30 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_30_ir_temperature_30_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_29_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_29_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_29 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_29 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_29_decode(
    struct vehicle_rt_ir_temp_temp_29_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_29 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_29 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_29_ir_temperature_29_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_28_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_28_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_28 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_28 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_28_decode(
    struct vehicle_rt_ir_temp_temp_28_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_28 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_28 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_28_ir_temperature_28_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_27_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_27_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_27 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_27 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_27_decode(
    struct vehicle_rt_ir_temp_temp_27_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_27 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_27 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_27_ir_temperature_27_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_26_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_26_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_26 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_26 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_26_decode(
    struct vehicle_rt_ir_temp_temp_26_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_26 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_26 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_26_ir_temperature_26_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_25_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_25_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_25 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_25 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_25_decode(
    struct vehicle_rt_ir_temp_temp_25_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_25 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_25 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_25_ir_temperature_25_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_24_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_24_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_24 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_24 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_24_decode(
    struct vehicle_rt_ir_temp_temp_24_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_24 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_24 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_24_ir_temperature_24_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_22_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_22_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_22 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_22 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_22_decode(
    struct vehicle_rt_ir_temp_temp_22_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_22 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_22 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_22_ir_temperature_22_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_23_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_23_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_23 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_23 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_23_decode(
    struct vehicle_rt_ir_temp_temp_23_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_23 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_23 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_23_ir_temperature_23_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_21_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_21_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_21 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_21 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_21_decode(
    struct vehicle_rt_ir_temp_temp_21_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_21 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_21 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_21_ir_temperature_21_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_20_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_20_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_20 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_20 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_20_decode(
    struct vehicle_rt_ir_temp_temp_20_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_20 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_20 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_20_ir_temperature_20_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_19_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_19_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_19 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_19 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_19_decode(
    struct vehicle_rt_ir_temp_temp_19_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_19 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_19 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_19_ir_temperature_19_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_18_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_18_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_18 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_18 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_18_decode(
    struct vehicle_rt_ir_temp_temp_18_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_18 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_18 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_18_ir_temperature_18_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_16_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_16_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_16 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_16 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_16_decode(
    struct vehicle_rt_ir_temp_temp_16_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_16 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_16 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_16_ir_temperature_16_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_15_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_15_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_15 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_15 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_15_decode(
    struct vehicle_rt_ir_temp_temp_15_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_15 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_15 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_15_ir_temperature_15_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_14_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_14_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_14 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_14 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_14_decode(
    struct vehicle_rt_ir_temp_temp_14_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_14 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_14 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_14_ir_temperature_14_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_13_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_13_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_13 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_13 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_13_decode(
    struct vehicle_rt_ir_temp_temp_13_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_13 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_13 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_13_ir_temperature_13_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_12_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_12_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_12 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_12 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_12_decode(
    struct vehicle_rt_ir_temp_temp_12_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_12 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_12 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_12_ir_temperature_12_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_11_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_11_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_11 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_11 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_11_decode(
    struct vehicle_rt_ir_temp_temp_11_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_11 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_11 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_11_ir_temperature_11_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_10_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_10_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_10 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_10 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_10_decode(
    struct vehicle_rt_ir_temp_temp_10_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_10 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_10 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_10_ir_temperature_10_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_8_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_8 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_8 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_8_decode(
    struct vehicle_rt_ir_temp_temp_8_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_8 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_8 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_8_ir_temperature_8_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_9_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_9_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_9 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_9 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_9_decode(
    struct vehicle_rt_ir_temp_temp_9_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_9 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_9 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_9_ir_temperature_9_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_17_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_17_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_17 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_17 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_17_decode(
    struct vehicle_rt_ir_temp_temp_17_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_17 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_17 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_17_ir_temperature_17_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_6_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_6_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_6 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_6 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_6_decode(
    struct vehicle_rt_ir_temp_temp_6_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_6 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_6 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_6_ir_temperature_6_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_5_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_5_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_5 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_5 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_5_decode(
    struct vehicle_rt_ir_temp_temp_5_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_5 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_5 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_5_ir_temperature_5_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_4_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_4_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_4 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_4 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_4_decode(
    struct vehicle_rt_ir_temp_temp_4_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_4 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_4 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_4_ir_temperature_4_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_3_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_3_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_3 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_3 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_3_decode(
    struct vehicle_rt_ir_temp_temp_3_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_3 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_3 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_3_ir_temperature_3_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_2_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_2 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_2 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_2_decode(
    struct vehicle_rt_ir_temp_temp_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_2 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_2 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_2_ir_temperature_2_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_ir_temp_temp_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_ir_temp_temp_1_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->ir_temperature_1 << 0) & 0xff);
    dst_p[1] |= ((src_p->ir_temperature_1 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_ir_temp_temp_1_decode(
    struct vehicle_rt_ir_temp_temp_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ir_temperature_1 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->ir_temperature_1 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_ir_temp_temp_1_ir_temperature_1_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_sb_trig_final_condition_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_trig_final_condition_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_final_speed << 0) & 0x01);
    dst_p[1] |= ((src_p->final_speed << 0) & 0xff);
    dst_p[2] |= ((src_p->final_speed >> 8) & 0xff);
    dst_p[3] |= ((src_p->final_speed >> 16) & 0xff);

    return (8);
}

int vehicle_rt_sb_trig_final_condition_decode(
    struct vehicle_rt_sb_trig_final_condition_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_final_speed |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->final_speed |= ((uint32_t)(src_p[1] & 0xff) >> 0);
    dst_p->final_speed |= ((uint32_t)(src_p[2] & 0xff) << 8);
    dst_p->final_speed |= ((uint32_t)(src_p[3] & 0xff) << 16);

    return (0);
}

bool vehicle_rt_sb_trig_final_condition_validity_final_speed_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_trig_final_condition_final_speed_is_in_range(uint32_t value)
{
    return (value <= 16750000u);
}

ssize_t vehicle_rt_sb_trig_initial_condition_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_trig_initial_condition_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_initial_speed << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_initial_heading << 1) & 0x02);
    dst_p[1] |= ((src_p->initial_speed << 0) & 0xff);
    dst_p[2] |= ((src_p->initial_speed >> 8) & 0xff);
    dst_p[3] |= ((src_p->initial_speed >> 16) & 0xff);
    dst_p[4] |= ((src_p->initial_heading << 0) & 0xff);
    dst_p[5] |= ((src_p->initial_heading >> 8) & 0xff);
    dst_p[6] |= ((src_p->mfdd_start_threshold << 0) & 0xff);
    dst_p[7] |= ((src_p->mfdd_end_threshold << 0) & 0xff);

    return (8);
}

int vehicle_rt_sb_trig_initial_condition_decode(
    struct vehicle_rt_sb_trig_initial_condition_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_initial_speed |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_initial_heading |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->initial_speed |= ((uint32_t)(src_p[1] & 0xff) >> 0);
    dst_p->initial_speed |= ((uint32_t)(src_p[2] & 0xff) << 8);
    dst_p->initial_speed |= ((uint32_t)(src_p[3] & 0xff) << 16);
    dst_p->initial_heading |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->initial_heading |= ((uint16_t)(src_p[5] & 0xff) << 8);
    dst_p->mfdd_start_threshold |= ((uint8_t)(src_p[6] & 0xff) >> 0);
    dst_p->mfdd_end_threshold |= ((uint8_t)(src_p[7] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_sb_trig_initial_condition_validity_initial_speed_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_trig_initial_condition_validity_initial_heading_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_trig_initial_condition_initial_speed_is_in_range(uint32_t value)
{
    return (value <= 16750000u);
}

bool vehicle_rt_sb_trig_initial_condition_initial_heading_is_in_range(int16_t value)
{
    return ((value >= -18000) && (value <= 18000));
}

bool vehicle_rt_sb_trig_initial_condition_mfdd_start_threshold_is_in_range(uint8_t value)
{
    return (value <= 100u);
}

bool vehicle_rt_sb_trig_initial_condition_mfdd_end_threshold_is_in_range(uint8_t value)
{
    return (value <= 100u);
}

ssize_t vehicle_rt_sb_trig_direct_dist_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_trig_direct_dist_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->direct_distance << 0) & 0xff);
    dst_p[1] |= ((src_p->direct_distance >> 8) & 0xff);
    dst_p[2] |= ((src_p->direct_distance >> 16) & 0xff);
    dst_p[3] |= ((src_p->direct_distance >> 24) & 0xff);
    dst_p[4] |= ((src_p->path_distance_2_d << 0) & 0xff);
    dst_p[5] |= ((src_p->path_distance_2_d >> 8) & 0xff);
    dst_p[6] |= ((src_p->path_distance_2_d >> 16) & 0xff);
    dst_p[7] |= ((src_p->path_distance_2_d >> 24) & 0xff);

    return (8);
}

int vehicle_rt_sb_trig_direct_dist_decode(
    struct vehicle_rt_sb_trig_direct_dist_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->direct_distance |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->direct_distance |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->direct_distance |= ((uint32_t)(src_p[2] & 0xff) << 16);
    dst_p->direct_distance |= ((uint32_t)(src_p[3] & 0xff) << 24);
    dst_p->path_distance_2_d |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->path_distance_2_d |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->path_distance_2_d |= ((uint32_t)(src_p[6] & 0xff) << 16);
    dst_p->path_distance_2_d |= ((uint32_t)(src_p[7] & 0xff) << 24);

    return (0);
}

bool vehicle_rt_sb_trig_direct_dist_direct_distance_is_in_range(uint32_t value)
{
    return (value <= 4294967000u);
}

bool vehicle_rt_sb_trig_direct_dist_path_distance_2_d_is_in_range(uint32_t value)
{
    return (value <= 4294967000u);
}

ssize_t vehicle_rt_sb_trig_forward_dist_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_trig_forward_dist_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->forward_distance << 0) & 0xff);
    dst_p[1] |= ((src_p->forward_distance >> 8) & 0xff);
    dst_p[2] |= ((src_p->forward_distance >> 16) & 0xff);
    dst_p[3] |= ((src_p->forward_distance >> 24) & 0xff);
    dst_p[4] |= ((src_p->deviation_distance << 0) & 0xff);
    dst_p[5] |= ((src_p->deviation_distance >> 8) & 0xff);
    dst_p[6] |= ((src_p->deviation_distance >> 16) & 0xff);
    dst_p[7] |= ((src_p->deviation_distance >> 24) & 0xff);

    return (8);
}

int vehicle_rt_sb_trig_forward_dist_decode(
    struct vehicle_rt_sb_trig_forward_dist_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->forward_distance |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->forward_distance |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->forward_distance |= ((uint32_t)(src_p[2] & 0xff) << 16);
    dst_p->forward_distance |= ((uint32_t)(src_p[3] & 0xff) << 24);
    dst_p->deviation_distance |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->deviation_distance |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->deviation_distance |= ((uint32_t)(src_p[6] & 0xff) << 16);
    dst_p->deviation_distance |= ((uint32_t)(src_p[7] & 0xff) << 24);

    return (0);
}

bool vehicle_rt_sb_trig_forward_dist_forward_distance_is_in_range(int32_t value)
{
    return (true);
}

bool vehicle_rt_sb_trig_forward_dist_deviation_distance_is_in_range(int32_t value)
{
    return (true);
}

ssize_t vehicle_rt_sb_trig_path_dist_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_trig_path_dist_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->path_distance_3_d << 0) & 0xff);
    dst_p[1] |= ((src_p->path_distance_3_d >> 8) & 0xff);
    dst_p[2] |= ((src_p->path_distance_3_d >> 16) & 0xff);
    dst_p[3] |= ((src_p->path_distance_3_d >> 24) & 0xff);

    return (8);
}

int vehicle_rt_sb_trig_path_dist_decode(
    struct vehicle_rt_sb_trig_path_dist_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->path_distance_3_d |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->path_distance_3_d |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->path_distance_3_d |= ((uint32_t)(src_p[2] & 0xff) << 16);
    dst_p->path_distance_3_d |= ((uint32_t)(src_p[3] & 0xff) << 24);

    return (0);
}

bool vehicle_rt_sb_trig_path_dist_path_distance_3_d_is_in_range(uint32_t value)
{
    return (value <= 4294967000u);
}

ssize_t vehicle_rt_sb_trig_accel_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_trig_accel_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_mfdd << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_average_accel << 1) & 0x02);
    dst_p[0] |= ((src_p->validity_triggered_time << 2) & 0x04);
    dst_p[1] |= ((src_p->mfdd << 0) & 0xff);
    dst_p[2] |= ((src_p->mfdd >> 8) & 0xff);
    dst_p[3] |= ((src_p->average_accel << 0) & 0xff);
    dst_p[4] |= ((src_p->average_accel >> 8) & 0xff);
    dst_p[5] |= ((src_p->triggered_time << 0) & 0xff);
    dst_p[6] |= ((src_p->triggered_time >> 8) & 0xff);
    dst_p[7] |= ((src_p->triggered_time >> 16) & 0xff);

    return (8);
}

int vehicle_rt_sb_trig_accel_decode(
    struct vehicle_rt_sb_trig_accel_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_mfdd |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_average_accel |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->validity_triggered_time |= ((uint8_t)(src_p[0] & 0x04) >> 2);
    dst_p->mfdd |= ((uint16_t)(src_p[1] & 0xff) >> 0);
    dst_p->mfdd |= ((uint16_t)(src_p[2] & 0xff) << 8);
    dst_p->average_accel |= ((uint16_t)(src_p[3] & 0xff) >> 0);
    dst_p->average_accel |= ((uint16_t)(src_p[4] & 0xff) << 8);
    dst_p->triggered_time |= ((uint32_t)(src_p[5] & 0xff) >> 0);
    dst_p->triggered_time |= ((uint32_t)(src_p[6] & 0xff) << 8);
    dst_p->triggered_time |= ((uint32_t)(src_p[7] & 0xff) << 16);

    return (0);
}

bool vehicle_rt_sb_trig_accel_validity_mfdd_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_trig_accel_validity_average_accel_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_trig_accel_validity_triggered_time_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_trig_accel_mfdd_is_in_range(int16_t value)
{
    return ((value >= -65000) && (value <= 65000));
}

bool vehicle_rt_sb_trig_accel_average_accel_is_in_range(int16_t value)
{
    return ((value >= -65000) && (value <= 65000));
}

bool vehicle_rt_sb_trig_accel_triggered_time_is_in_range(uint32_t value)
{
    return (value <= 16777200u);
}

ssize_t vehicle_rt_dl1_mk3_measure_time_12_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_measure_time_12_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 3);

    dst_p[0] |= ((src_p->measured_time_12 << 0) & 0xff);
    dst_p[1] |= ((src_p->measured_time_12 >> 8) & 0xff);
    dst_p[2] |= ((src_p->measured_time_12 >> 16) & 0xff);

    return (3);
}

int vehicle_rt_dl1_mk3_measure_time_12_decode(
    struct vehicle_rt_dl1_mk3_measure_time_12_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->measured_time_12 |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->measured_time_12 |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->measured_time_12 |= ((uint32_t)(src_p[2] & 0xff) << 16);

    return (0);
}

bool vehicle_rt_dl1_mk3_measure_time_12_measured_time_12_is_in_range(uint32_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_measure_time_11_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_measure_time_11_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 3);

    dst_p[0] |= ((src_p->measured_time_11 << 0) & 0xff);
    dst_p[1] |= ((src_p->measured_time_11 >> 8) & 0xff);
    dst_p[2] |= ((src_p->measured_time_11 >> 16) & 0xff);

    return (3);
}

int vehicle_rt_dl1_mk3_measure_time_11_decode(
    struct vehicle_rt_dl1_mk3_measure_time_11_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->measured_time_11 |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->measured_time_11 |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->measured_time_11 |= ((uint32_t)(src_p[2] & 0xff) << 16);

    return (0);
}

bool vehicle_rt_dl1_mk3_measure_time_11_measured_time_11_is_in_range(uint32_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_measure_time_10_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_measure_time_10_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 3);

    dst_p[0] |= ((src_p->measured_time_10 << 0) & 0xff);
    dst_p[1] |= ((src_p->measured_time_10 >> 8) & 0xff);
    dst_p[2] |= ((src_p->measured_time_10 >> 16) & 0xff);

    return (3);
}

int vehicle_rt_dl1_mk3_measure_time_10_decode(
    struct vehicle_rt_dl1_mk3_measure_time_10_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->measured_time_10 |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->measured_time_10 |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->measured_time_10 |= ((uint32_t)(src_p[2] & 0xff) << 16);

    return (0);
}

bool vehicle_rt_dl1_mk3_measure_time_10_measured_time_10_is_in_range(uint32_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_measure_time_9_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_measure_time_9_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 3);

    dst_p[0] |= ((src_p->measured_time_9 << 0) & 0xff);
    dst_p[1] |= ((src_p->measured_time_9 >> 8) & 0xff);
    dst_p[2] |= ((src_p->measured_time_9 >> 16) & 0xff);

    return (3);
}

int vehicle_rt_dl1_mk3_measure_time_9_decode(
    struct vehicle_rt_dl1_mk3_measure_time_9_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->measured_time_9 |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->measured_time_9 |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->measured_time_9 |= ((uint32_t)(src_p[2] & 0xff) << 16);

    return (0);
}

bool vehicle_rt_dl1_mk3_measure_time_9_measured_time_9_is_in_range(uint32_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_measure_time_8_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_measure_time_8_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 3);

    dst_p[0] |= ((src_p->measured_time_8 << 0) & 0xff);
    dst_p[1] |= ((src_p->measured_time_8 >> 8) & 0xff);
    dst_p[2] |= ((src_p->measured_time_8 >> 16) & 0xff);

    return (3);
}

int vehicle_rt_dl1_mk3_measure_time_8_decode(
    struct vehicle_rt_dl1_mk3_measure_time_8_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->measured_time_8 |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->measured_time_8 |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->measured_time_8 |= ((uint32_t)(src_p[2] & 0xff) << 16);

    return (0);
}

bool vehicle_rt_dl1_mk3_measure_time_8_measured_time_8_is_in_range(uint32_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_measure_time_7_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_measure_time_7_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 3);

    dst_p[0] |= ((src_p->measured_time_7 << 0) & 0xff);
    dst_p[1] |= ((src_p->measured_time_7 >> 8) & 0xff);
    dst_p[2] |= ((src_p->measured_time_7 >> 16) & 0xff);

    return (3);
}

int vehicle_rt_dl1_mk3_measure_time_7_decode(
    struct vehicle_rt_dl1_mk3_measure_time_7_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->measured_time_7 |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->measured_time_7 |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->measured_time_7 |= ((uint32_t)(src_p[2] & 0xff) << 16);

    return (0);
}

bool vehicle_rt_dl1_mk3_measure_time_7_measured_time_7_is_in_range(uint32_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_measure_time_6_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_measure_time_6_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 3);

    dst_p[0] |= ((src_p->measured_time_6 << 0) & 0xff);
    dst_p[1] |= ((src_p->measured_time_6 >> 8) & 0xff);
    dst_p[2] |= ((src_p->measured_time_6 >> 16) & 0xff);

    return (3);
}

int vehicle_rt_dl1_mk3_measure_time_6_decode(
    struct vehicle_rt_dl1_mk3_measure_time_6_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->measured_time_6 |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->measured_time_6 |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->measured_time_6 |= ((uint32_t)(src_p[2] & 0xff) << 16);

    return (0);
}

bool vehicle_rt_dl1_mk3_measure_time_6_measured_time_6_is_in_range(uint32_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_measure_time_5_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_measure_time_5_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 3);

    dst_p[0] |= ((src_p->measured_time_5 << 0) & 0xff);
    dst_p[1] |= ((src_p->measured_time_5 >> 8) & 0xff);
    dst_p[2] |= ((src_p->measured_time_5 >> 16) & 0xff);

    return (3);
}

int vehicle_rt_dl1_mk3_measure_time_5_decode(
    struct vehicle_rt_dl1_mk3_measure_time_5_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->measured_time_5 |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->measured_time_5 |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->measured_time_5 |= ((uint32_t)(src_p[2] & 0xff) << 16);

    return (0);
}

bool vehicle_rt_dl1_mk3_measure_time_5_measured_time_5_is_in_range(uint32_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_measure_time_4_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_measure_time_4_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 3);

    dst_p[0] |= ((src_p->measured_time_4 << 0) & 0xff);
    dst_p[1] |= ((src_p->measured_time_4 >> 8) & 0xff);
    dst_p[2] |= ((src_p->measured_time_4 >> 16) & 0xff);

    return (3);
}

int vehicle_rt_dl1_mk3_measure_time_4_decode(
    struct vehicle_rt_dl1_mk3_measure_time_4_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->measured_time_4 |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->measured_time_4 |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->measured_time_4 |= ((uint32_t)(src_p[2] & 0xff) << 16);

    return (0);
}

bool vehicle_rt_dl1_mk3_measure_time_4_measured_time_4_is_in_range(uint32_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_measure_time_3_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_measure_time_3_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 3);

    dst_p[0] |= ((src_p->measured_time_3 << 0) & 0xff);
    dst_p[1] |= ((src_p->measured_time_3 >> 8) & 0xff);
    dst_p[2] |= ((src_p->measured_time_3 >> 16) & 0xff);

    return (3);
}

int vehicle_rt_dl1_mk3_measure_time_3_decode(
    struct vehicle_rt_dl1_mk3_measure_time_3_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->measured_time_3 |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->measured_time_3 |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->measured_time_3 |= ((uint32_t)(src_p[2] & 0xff) << 16);

    return (0);
}

bool vehicle_rt_dl1_mk3_measure_time_3_measured_time_3_is_in_range(uint32_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_measure_time_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_measure_time_2_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 3);

    dst_p[0] |= ((src_p->measured_time_2 << 0) & 0xff);
    dst_p[1] |= ((src_p->measured_time_2 >> 8) & 0xff);
    dst_p[2] |= ((src_p->measured_time_2 >> 16) & 0xff);

    return (3);
}

int vehicle_rt_dl1_mk3_measure_time_2_decode(
    struct vehicle_rt_dl1_mk3_measure_time_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->measured_time_2 |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->measured_time_2 |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->measured_time_2 |= ((uint32_t)(src_p[2] & 0xff) << 16);

    return (0);
}

bool vehicle_rt_dl1_mk3_measure_time_2_measured_time_2_is_in_range(uint32_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_measure_time_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_measure_time_1_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 3);

    dst_p[0] |= ((src_p->measured_time_1 << 0) & 0xff);
    dst_p[1] |= ((src_p->measured_time_1 >> 8) & 0xff);
    dst_p[2] |= ((src_p->measured_time_1 >> 16) & 0xff);

    return (3);
}

int vehicle_rt_dl1_mk3_measure_time_1_decode(
    struct vehicle_rt_dl1_mk3_measure_time_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->measured_time_1 |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->measured_time_1 |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->measured_time_1 |= ((uint32_t)(src_p[2] & 0xff) << 16);

    return (0);
}

bool vehicle_rt_dl1_mk3_measure_time_1_measured_time_1_is_in_range(uint32_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_rpm_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_rpm_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->rpm << 0) & 0xff);
    dst_p[1] |= ((src_p->rpm >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_rpm_decode(
    struct vehicle_rt_dl1_mk3_rpm_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->rpm |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->rpm |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_rpm_rpm_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_freq_4_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_freq_4_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->frequency_4 << 0) & 0xff);
    dst_p[1] |= ((src_p->frequency_4 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_freq_4_decode(
    struct vehicle_rt_dl1_mk3_freq_4_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->frequency_4 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->frequency_4 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_freq_4_frequency_4_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_freq_3_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_freq_3_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->frequency_3 << 0) & 0xff);
    dst_p[1] |= ((src_p->frequency_3 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_freq_3_decode(
    struct vehicle_rt_dl1_mk3_freq_3_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->frequency_3 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->frequency_3 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_freq_3_frequency_3_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_freq_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_freq_2_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->frequency_2 << 0) & 0xff);
    dst_p[1] |= ((src_p->frequency_2 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_freq_2_decode(
    struct vehicle_rt_dl1_mk3_freq_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->frequency_2 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->frequency_2 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_freq_2_frequency_2_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_misc_3_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_misc_3_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->misc_3 << 0) & 0xff);
    dst_p[1] |= ((src_p->misc_3 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_misc_3_decode(
    struct vehicle_rt_dl1_mk3_misc_3_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->misc_3 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->misc_3 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_misc_3_misc_3_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_misc_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_misc_2_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->misc_2 << 0) & 0xff);
    dst_p[1] |= ((src_p->misc_2 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_misc_2_decode(
    struct vehicle_rt_dl1_mk3_misc_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->misc_2 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->misc_2 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_misc_2_misc_2_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_misc_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_misc_1_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->misc_1 << 0) & 0xff);
    dst_p[1] |= ((src_p->misc_1 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_misc_1_decode(
    struct vehicle_rt_dl1_mk3_misc_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->misc_1 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->misc_1 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_misc_1_misc_1_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_31_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_31_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_31 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_31 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_31_decode(
    struct vehicle_rt_dl1_mk3_aux_31_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_31 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_31 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_31_aux_31_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_30_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_30_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_30 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_30 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_30_decode(
    struct vehicle_rt_dl1_mk3_aux_30_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_30 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_30 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_30_aux_30_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_29_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_29_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_29 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_29 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_29_decode(
    struct vehicle_rt_dl1_mk3_aux_29_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_29 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_29 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_29_aux_29_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_28_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_28_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_28 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_28 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_28_decode(
    struct vehicle_rt_dl1_mk3_aux_28_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_28 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_28 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_28_aux_28_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_27_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_27_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_27 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_27 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_27_decode(
    struct vehicle_rt_dl1_mk3_aux_27_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_27 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_27 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_27_aux_27_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_26_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_26_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_26 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_26 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_26_decode(
    struct vehicle_rt_dl1_mk3_aux_26_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_26 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_26 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_26_aux_26_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_25_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_25_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_25 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_25 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_25_decode(
    struct vehicle_rt_dl1_mk3_aux_25_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_25 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_25 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_25_aux_25_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_24_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_24_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_24 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_24 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_24_decode(
    struct vehicle_rt_dl1_mk3_aux_24_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_24 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_24 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_24_aux_24_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_23_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_23_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_23 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_23 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_23_decode(
    struct vehicle_rt_dl1_mk3_aux_23_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_23 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_23 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_23_aux_23_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_22_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_22_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_22 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_22 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_22_decode(
    struct vehicle_rt_dl1_mk3_aux_22_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_22 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_22 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_22_aux_22_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_21_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_21_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_21 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_21 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_21_decode(
    struct vehicle_rt_dl1_mk3_aux_21_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_21 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_21 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_21_aux_21_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_20_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_20_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_20 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_20 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_20_decode(
    struct vehicle_rt_dl1_mk3_aux_20_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_20 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_20 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_20_aux_20_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_19_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_19_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_19 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_19 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_19_decode(
    struct vehicle_rt_dl1_mk3_aux_19_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_19 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_19 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_19_aux_19_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_18_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_18_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_18 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_18 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_18_decode(
    struct vehicle_rt_dl1_mk3_aux_18_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_18 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_18 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_18_aux_18_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_17_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_17_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_17 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_17 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_17_decode(
    struct vehicle_rt_dl1_mk3_aux_17_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_17 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_17 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_17_aux_17_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_16_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_16_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_16 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_16 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_16_decode(
    struct vehicle_rt_dl1_mk3_aux_16_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_16 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_16 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_16_aux_16_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_15_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_15_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_15 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_15 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_15_decode(
    struct vehicle_rt_dl1_mk3_aux_15_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_15 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_15 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_15_aux_15_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_14_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_14_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_14 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_14 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_14_decode(
    struct vehicle_rt_dl1_mk3_aux_14_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_14 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_14 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_14_aux_14_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_13_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_13_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_13 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_13 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_13_decode(
    struct vehicle_rt_dl1_mk3_aux_13_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_13 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_13 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_13_aux_13_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_12_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_12_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_12 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_12 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_12_decode(
    struct vehicle_rt_dl1_mk3_aux_12_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_12 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_12 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_12_aux_12_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_11_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_11_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_11 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_11 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_11_decode(
    struct vehicle_rt_dl1_mk3_aux_11_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_11 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_11 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_11_aux_11_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_9_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_9_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_9 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_9 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_9_decode(
    struct vehicle_rt_dl1_mk3_aux_9_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_9 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_9 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_9_aux_9_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_10_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_10_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_10 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_10 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_10_decode(
    struct vehicle_rt_dl1_mk3_aux_10_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_10 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_10 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_10_aux_10_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_8_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_8 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_8 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_8_decode(
    struct vehicle_rt_dl1_mk3_aux_8_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_8 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_8 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_8_aux_8_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_7_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_7_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_7 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_7 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_7_decode(
    struct vehicle_rt_dl1_mk3_aux_7_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_7 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_7 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_7_aux_7_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_6_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_6_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_6 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_6 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_6_decode(
    struct vehicle_rt_dl1_mk3_aux_6_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_6 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_6 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_6_aux_6_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_5_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_5_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_5 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_5 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_5_decode(
    struct vehicle_rt_dl1_mk3_aux_5_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_5 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_5 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_5_aux_5_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_4_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_4_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_4 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_4 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_4_decode(
    struct vehicle_rt_dl1_mk3_aux_4_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_4 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_4 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_4_aux_4_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_3_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_3_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_3 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_3 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_3_decode(
    struct vehicle_rt_dl1_mk3_aux_3_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_3 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_3 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_3_aux_3_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_2_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_2 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_2 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_2_decode(
    struct vehicle_rt_dl1_mk3_aux_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_2 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_2 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_2_aux_2_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_aux_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_aux_1_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->aux_1 << 0) & 0xff);
    dst_p[1] |= ((src_p->aux_1 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_aux_1_decode(
    struct vehicle_rt_dl1_mk3_aux_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->aux_1 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->aux_1 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_aux_1_aux_1_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_pressure_5_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_pressure_5_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 3);

    dst_p[0] |= ((src_p->pressure_5 << 0) & 0xff);
    dst_p[1] |= ((src_p->pressure_5 >> 8) & 0xff);
    dst_p[2] |= ((src_p->pressure_5 >> 16) & 0xff);

    return (3);
}

int vehicle_rt_dl1_mk3_pressure_5_decode(
    struct vehicle_rt_dl1_mk3_pressure_5_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->pressure_5 |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->pressure_5 |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->pressure_5 |= ((uint32_t)(src_p[2] & 0xff) << 16);

    return (0);
}

bool vehicle_rt_dl1_mk3_pressure_5_pressure_5_is_in_range(uint32_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_pressure_4_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_pressure_4_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 3);

    dst_p[0] |= ((src_p->pressure_4 << 0) & 0xff);
    dst_p[1] |= ((src_p->pressure_4 >> 8) & 0xff);
    dst_p[2] |= ((src_p->pressure_4 >> 16) & 0xff);

    return (3);
}

int vehicle_rt_dl1_mk3_pressure_4_decode(
    struct vehicle_rt_dl1_mk3_pressure_4_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->pressure_4 |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->pressure_4 |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->pressure_4 |= ((uint32_t)(src_p[2] & 0xff) << 16);

    return (0);
}

bool vehicle_rt_dl1_mk3_pressure_4_pressure_4_is_in_range(uint32_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_pressure_3_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_pressure_3_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 3);

    dst_p[0] |= ((src_p->pressure_3 << 0) & 0xff);
    dst_p[1] |= ((src_p->pressure_3 >> 8) & 0xff);
    dst_p[2] |= ((src_p->pressure_3 >> 16) & 0xff);

    return (3);
}

int vehicle_rt_dl1_mk3_pressure_3_decode(
    struct vehicle_rt_dl1_mk3_pressure_3_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->pressure_3 |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->pressure_3 |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->pressure_3 |= ((uint32_t)(src_p[2] & 0xff) << 16);

    return (0);
}

bool vehicle_rt_dl1_mk3_pressure_3_pressure_3_is_in_range(uint32_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_pressure_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_pressure_2_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 3);

    dst_p[0] |= ((src_p->pressure_2 << 0) & 0xff);
    dst_p[1] |= ((src_p->pressure_2 >> 8) & 0xff);
    dst_p[2] |= ((src_p->pressure_2 >> 16) & 0xff);

    return (3);
}

int vehicle_rt_dl1_mk3_pressure_2_decode(
    struct vehicle_rt_dl1_mk3_pressure_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->pressure_2 |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->pressure_2 |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->pressure_2 |= ((uint32_t)(src_p[2] & 0xff) << 16);

    return (0);
}

bool vehicle_rt_dl1_mk3_pressure_2_pressure_2_is_in_range(uint32_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_pressure_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_pressure_1_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 3);

    dst_p[0] |= ((src_p->pressure_1 << 0) & 0xff);
    dst_p[1] |= ((src_p->pressure_1 >> 8) & 0xff);
    dst_p[2] |= ((src_p->pressure_1 >> 16) & 0xff);

    return (3);
}

int vehicle_rt_dl1_mk3_pressure_1_decode(
    struct vehicle_rt_dl1_mk3_pressure_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 3) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->pressure_1 |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->pressure_1 |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->pressure_1 |= ((uint32_t)(src_p[2] & 0xff) << 16);

    return (0);
}

bool vehicle_rt_dl1_mk3_pressure_1_pressure_1_is_in_range(uint32_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_angle_3_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_angle_3_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->angle_3 << 0) & 0xff);
    dst_p[1] |= ((src_p->angle_3 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_angle_3_decode(
    struct vehicle_rt_dl1_mk3_angle_3_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->angle_3 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->angle_3 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_angle_3_angle_3_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_angle_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_angle_2_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->angle_2 << 0) & 0xff);
    dst_p[1] |= ((src_p->angle_2 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_angle_2_decode(
    struct vehicle_rt_dl1_mk3_angle_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->angle_2 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->angle_2 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_angle_2_angle_2_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_angle_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_angle_1_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->angle_1 << 0) & 0xff);
    dst_p[1] |= ((src_p->angle_1 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_angle_1_decode(
    struct vehicle_rt_dl1_mk3_angle_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->angle_1 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->angle_1 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_angle_1_angle_1_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_25_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_25_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_25 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_25 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_25_decode(
    struct vehicle_rt_dl1_mk3_temp_25_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_25 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_25 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_25_temperature_25_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_24_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_24_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_24 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_24 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_24_decode(
    struct vehicle_rt_dl1_mk3_temp_24_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_24 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_24 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_24_temperature_24_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_23_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_23_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_23 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_23 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_23_decode(
    struct vehicle_rt_dl1_mk3_temp_23_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_23 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_23 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_23_temperature_23_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_22_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_22_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_22 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_22 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_22_decode(
    struct vehicle_rt_dl1_mk3_temp_22_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_22 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_22 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_22_temperature_22_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_21_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_21_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_21 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_21 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_21_decode(
    struct vehicle_rt_dl1_mk3_temp_21_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_21 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_21 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_21_temperature_21_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_20_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_20_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_20 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_20 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_20_decode(
    struct vehicle_rt_dl1_mk3_temp_20_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_20 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_20 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_20_temperature_20_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_19_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_19_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_19 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_19 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_19_decode(
    struct vehicle_rt_dl1_mk3_temp_19_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_19 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_19 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_19_temperature_19_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_18_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_18_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_18 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_18 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_18_decode(
    struct vehicle_rt_dl1_mk3_temp_18_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_18 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_18 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_18_temperature_18_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_17_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_17_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_17 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_17 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_17_decode(
    struct vehicle_rt_dl1_mk3_temp_17_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_17 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_17 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_17_temperature_17_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_16_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_16_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_16 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_16 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_16_decode(
    struct vehicle_rt_dl1_mk3_temp_16_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_16 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_16 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_16_temperature_16_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_15_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_15_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_15 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_15 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_15_decode(
    struct vehicle_rt_dl1_mk3_temp_15_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_15 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_15 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_15_temperature_15_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_14_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_14_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_14 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_14 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_14_decode(
    struct vehicle_rt_dl1_mk3_temp_14_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_14 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_14 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_14_temperature_14_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_13_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_13_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_13 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_13 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_13_decode(
    struct vehicle_rt_dl1_mk3_temp_13_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_13 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_13 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_13_temperature_13_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_12_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_12_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_12 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_12 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_12_decode(
    struct vehicle_rt_dl1_mk3_temp_12_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_12 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_12 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_12_temperature_12_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_11_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_11_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_11 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_11 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_11_decode(
    struct vehicle_rt_dl1_mk3_temp_11_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_11 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_11 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_11_temperature_11_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_10_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_10_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_10 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_10 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_10_decode(
    struct vehicle_rt_dl1_mk3_temp_10_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_10 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_10 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_10_temperature_10_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_9_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_9_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_9 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_9 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_9_decode(
    struct vehicle_rt_dl1_mk3_temp_9_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_9 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_9 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_9_temperature_9_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_8_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_8 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_8 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_8_decode(
    struct vehicle_rt_dl1_mk3_temp_8_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_8 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_8 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_8_temperature_8_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_7_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_7_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_7 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_7 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_7_decode(
    struct vehicle_rt_dl1_mk3_temp_7_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_7 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_7 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_7_temperature_7_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_6_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_6_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_6 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_6 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_6_decode(
    struct vehicle_rt_dl1_mk3_temp_6_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_6 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_6 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_6_temperature_6_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_5_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_5_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_5 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_5 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_5_decode(
    struct vehicle_rt_dl1_mk3_temp_5_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_5 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_5 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_5_temperature_5_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_4_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_4_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_4 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_4 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_4_decode(
    struct vehicle_rt_dl1_mk3_temp_4_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_4 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_4 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_4_temperature_4_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_3_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_3_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_3 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_3 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_3_decode(
    struct vehicle_rt_dl1_mk3_temp_3_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_3 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_3 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_3_temperature_3_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_2_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_2 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_2 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_2_decode(
    struct vehicle_rt_dl1_mk3_temp_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_2 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_2 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_2_temperature_2_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_temp_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_temp_1_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->temperature_1 << 0) & 0xff);
    dst_p[1] |= ((src_p->temperature_1 >> 8) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_temp_1_decode(
    struct vehicle_rt_dl1_mk3_temp_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->temperature_1 |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->temperature_1 |= ((uint16_t)(src_p[1] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_temp_1_temperature_1_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_32_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_32_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_32 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_32 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_32_decode(
    struct vehicle_rt_dl1_mk3_analog_32_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_32 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_32 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_32_analog_32_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_31_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_31_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_31 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_31 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_31_decode(
    struct vehicle_rt_dl1_mk3_analog_31_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_31 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_31 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_31_analog_31_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_30_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_30_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_30 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_30 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_30_decode(
    struct vehicle_rt_dl1_mk3_analog_30_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_30 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_30 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_30_analog_30_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_29_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_29_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_29 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_29 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_29_decode(
    struct vehicle_rt_dl1_mk3_analog_29_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_29 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_29 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_29_analog_29_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_28_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_28_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_28 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_28 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_28_decode(
    struct vehicle_rt_dl1_mk3_analog_28_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_28 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_28 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_28_analog_28_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_27_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_27_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_27 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_27 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_27_decode(
    struct vehicle_rt_dl1_mk3_analog_27_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_27 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_27 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_27_analog_27_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_26_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_26_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_26 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_26 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_26_decode(
    struct vehicle_rt_dl1_mk3_analog_26_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_26 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_26 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_26_analog_26_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_25_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_25_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_25 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_25 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_25_decode(
    struct vehicle_rt_dl1_mk3_analog_25_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_25 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_25 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_25_analog_25_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_15_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_15_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_15 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_15 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_15_decode(
    struct vehicle_rt_dl1_mk3_analog_15_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_15 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_15 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_15_analog_15_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_14_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_14_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_14 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_14 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_14_decode(
    struct vehicle_rt_dl1_mk3_analog_14_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_14 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_14 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_14_analog_14_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_17_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_17_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_17 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_17 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_17_decode(
    struct vehicle_rt_dl1_mk3_analog_17_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_17 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_17 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_17_analog_17_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_24_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_24_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_24 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_24 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_24_decode(
    struct vehicle_rt_dl1_mk3_analog_24_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_24 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_24 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_24_analog_24_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_23_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_23_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_23 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_23 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_23_decode(
    struct vehicle_rt_dl1_mk3_analog_23_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_23 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_23 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_23_analog_23_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_22_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_22_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_22 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_22 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_22_decode(
    struct vehicle_rt_dl1_mk3_analog_22_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_22 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_22 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_22_analog_22_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_21_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_21_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_21 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_21 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_21_decode(
    struct vehicle_rt_dl1_mk3_analog_21_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_21 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_21 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_21_analog_21_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_20_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_20_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_20 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_20 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_20_decode(
    struct vehicle_rt_dl1_mk3_analog_20_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_20 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_20 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_20_analog_20_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_19_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_19_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_19 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_19 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_19_decode(
    struct vehicle_rt_dl1_mk3_analog_19_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_19 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_19 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_19_analog_19_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_16_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_16_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_16 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_16 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_16_decode(
    struct vehicle_rt_dl1_mk3_analog_16_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_16 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_16 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_16_analog_16_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_18_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_18_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_18 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_18 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_18_decode(
    struct vehicle_rt_dl1_mk3_analog_18_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_18 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_18 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_18_analog_18_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_12_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_12_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_12 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_12 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_12_decode(
    struct vehicle_rt_dl1_mk3_analog_12_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_12 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_12 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_12_analog_12_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_11_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_11_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_11 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_11 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_11_decode(
    struct vehicle_rt_dl1_mk3_analog_11_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_11 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_11 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_11_analog_11_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_10_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_10_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_10 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_10 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_10_decode(
    struct vehicle_rt_dl1_mk3_analog_10_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_10 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_10 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_10_analog_10_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_9_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_9_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_9 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_9 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_9_decode(
    struct vehicle_rt_dl1_mk3_analog_9_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_9 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_9 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_9_analog_9_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_8_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_8 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_8 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_8_decode(
    struct vehicle_rt_dl1_mk3_analog_8_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_8 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_8 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_8_analog_8_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_7_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_7_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_7 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_7 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_7_decode(
    struct vehicle_rt_dl1_mk3_analog_7_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_7 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_7 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_7_analog_7_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_6_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_6_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_6 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_6 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_6_decode(
    struct vehicle_rt_dl1_mk3_analog_6_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_6 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_6 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_6_analog_6_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_5_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_5_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_5 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_5 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_5_decode(
    struct vehicle_rt_dl1_mk3_analog_5_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_5 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_5 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_5_analog_5_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_4_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_4_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_4 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_4 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_4_decode(
    struct vehicle_rt_dl1_mk3_analog_4_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_4 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_4 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_4_analog_4_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_3_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_3_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_3 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_3 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_3_decode(
    struct vehicle_rt_dl1_mk3_analog_3_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_3 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_3 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_3_analog_3_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_2_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_2 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_2 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_2_decode(
    struct vehicle_rt_dl1_mk3_analog_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_2 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_2 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_2_analog_2_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_analog_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_analog_1_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 2);

    dst_p[0] |= ((src_p->analog_1 >> 8) & 0xff);
    dst_p[1] |= ((src_p->analog_1 << 0) & 0xff);

    return (2);
}

int vehicle_rt_dl1_mk3_analog_1_decode(
    struct vehicle_rt_dl1_mk3_analog_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 2) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->analog_1 |= ((uint16_t)(src_p[0] & 0xff) << 8);
    dst_p->analog_1 |= ((uint16_t)(src_p[1] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_dl1_mk3_analog_1_analog_1_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_dl1_mk3_accel_encode(
    uint8_t *dst_p,
    struct vehicle_rt_dl1_mk3_accel_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_accel_longitudinal << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_accel_lateral << 1) & 0x02);
    dst_p[0] |= ((src_p->validity_accel_vertical << 2) & 0x04);
    dst_p[1] |= ((src_p->accuracy_accel << 0) & 0xff);
    dst_p[2] |= ((src_p->accel_longitudinal << 0) & 0xff);
    dst_p[3] |= ((src_p->accel_longitudinal >> 8) & 0xff);
    dst_p[4] |= ((src_p->accel_lateral << 0) & 0xff);
    dst_p[5] |= ((src_p->accel_lateral >> 8) & 0xff);
    dst_p[6] |= ((src_p->accel_vertical << 0) & 0xff);
    dst_p[7] |= ((src_p->accel_vertical >> 8) & 0xff);

    return (8);
}

int vehicle_rt_dl1_mk3_accel_decode(
    struct vehicle_rt_dl1_mk3_accel_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_accel_longitudinal |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_accel_lateral |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->validity_accel_vertical |= ((uint8_t)(src_p[0] & 0x04) >> 2);
    dst_p->accuracy_accel |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->accel_longitudinal |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->accel_longitudinal |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->accel_lateral |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->accel_lateral |= ((uint16_t)(src_p[5] & 0xff) << 8);
    dst_p->accel_vertical |= ((uint16_t)(src_p[6] & 0xff) >> 0);
    dst_p->accel_vertical |= ((uint16_t)(src_p[7] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_dl1_mk3_accel_validity_accel_longitudinal_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_dl1_mk3_accel_validity_accel_lateral_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_dl1_mk3_accel_validity_accel_vertical_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_dl1_mk3_accel_accuracy_accel_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_dl1_mk3_accel_accel_longitudinal_is_in_range(int16_t value)
{
    return ((value >= -65000) && (value <= 65000));
}

bool vehicle_rt_dl1_mk3_accel_accel_lateral_is_in_range(int16_t value)
{
    return ((value >= -65000) && (value <= 65000));
}

bool vehicle_rt_dl1_mk3_accel_accel_vertical_is_in_range(int16_t value)
{
    return ((value >= -65000) && (value <= 65000));
}

ssize_t vehicle_rt_sb_ins_vpt_4_vel_ned_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_vpt_4_vel_ned_2_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->virtual_4_vel_ned_d << 0) & 0xff);
    dst_p[1] |= ((src_p->virtual_4_vel_ned_d >> 8) & 0xff);
    dst_p[2] |= ((src_p->virtual_4_vel_ned_d >> 16) & 0xff);
    dst_p[4] |= ((src_p->virtual_4_heading << 0) & 0xff);
    dst_p[5] |= ((src_p->virtual_4_heading >> 8) & 0xff);
    dst_p[6] |= ((src_p->virtual_4_slip << 0) & 0xff);
    dst_p[7] |= ((src_p->virtual_4_slip >> 8) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_vpt_4_vel_ned_2_decode(
    struct vehicle_rt_sb_ins_vpt_4_vel_ned_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->virtual_4_vel_ned_d |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->virtual_4_vel_ned_d |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->virtual_4_vel_ned_d |= ((uint32_t)(src_p[2] & 0xff) << 16);

    if (dst_p->virtual_4_vel_ned_d & (1 << 23)) {
        dst_p->virtual_4_vel_ned_d |= 0xff000000;
    }

    dst_p->virtual_4_heading |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->virtual_4_heading |= ((uint16_t)(src_p[5] & 0xff) << 8);
    dst_p->virtual_4_slip |= ((uint16_t)(src_p[6] & 0xff) >> 0);
    dst_p->virtual_4_slip |= ((uint16_t)(src_p[7] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_sb_ins_vpt_4_vel_ned_2_virtual_4_vel_ned_d_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

bool vehicle_rt_sb_ins_vpt_4_vel_ned_2_virtual_4_heading_is_in_range(int16_t value)
{
    return ((value >= -18000) && (value <= 18000));
}

bool vehicle_rt_sb_ins_vpt_4_vel_ned_2_virtual_4_slip_is_in_range(int16_t value)
{
    return ((value >= -18000) && (value <= 18000));
}

ssize_t vehicle_rt_sb_ins_vpt_4_vel_ned_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_vpt_4_vel_ned_1_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->virtual_4_vel_ned_n << 0) & 0xff);
    dst_p[1] |= ((src_p->virtual_4_vel_ned_n >> 8) & 0xff);
    dst_p[2] |= ((src_p->virtual_4_vel_ned_n >> 16) & 0xff);
    dst_p[4] |= ((src_p->virtual_4_vel_ned_e << 0) & 0xff);
    dst_p[5] |= ((src_p->virtual_4_vel_ned_e >> 8) & 0xff);
    dst_p[6] |= ((src_p->virtual_4_vel_ned_e >> 16) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_vpt_4_vel_ned_1_decode(
    struct vehicle_rt_sb_ins_vpt_4_vel_ned_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->virtual_4_vel_ned_n |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->virtual_4_vel_ned_n |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->virtual_4_vel_ned_n |= ((uint32_t)(src_p[2] & 0xff) << 16);

    if (dst_p->virtual_4_vel_ned_n & (1 << 23)) {
        dst_p->virtual_4_vel_ned_n |= 0xff000000;
    }

    dst_p->virtual_4_vel_ned_e |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->virtual_4_vel_ned_e |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->virtual_4_vel_ned_e |= ((uint32_t)(src_p[6] & 0xff) << 16);

    if (dst_p->virtual_4_vel_ned_e & (1 << 23)) {
        dst_p->virtual_4_vel_ned_e |= 0xff000000;
    }

    return (0);
}

bool vehicle_rt_sb_ins_vpt_4_vel_ned_1_virtual_4_vel_ned_n_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

bool vehicle_rt_sb_ins_vpt_4_vel_ned_1_virtual_4_vel_ned_e_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

ssize_t vehicle_rt_sb_ins_vpt_4_offset_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_vpt_4_offset_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->virtual_4_offset_x << 0) & 0xff);
    dst_p[1] |= ((src_p->virtual_4_offset_x >> 8) & 0xff);
    dst_p[2] |= ((src_p->virtual_4_offset_y << 0) & 0xff);
    dst_p[3] |= ((src_p->virtual_4_offset_y >> 8) & 0xff);
    dst_p[4] |= ((src_p->virtual_4_offset_z << 0) & 0xff);
    dst_p[5] |= ((src_p->virtual_4_offset_z >> 8) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_vpt_4_offset_decode(
    struct vehicle_rt_sb_ins_vpt_4_offset_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->virtual_4_offset_x |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->virtual_4_offset_x |= ((uint16_t)(src_p[1] & 0xff) << 8);
    dst_p->virtual_4_offset_y |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->virtual_4_offset_y |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->virtual_4_offset_z |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->virtual_4_offset_z |= ((uint16_t)(src_p[5] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_sb_ins_vpt_4_offset_virtual_4_offset_x_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_vpt_4_offset_virtual_4_offset_y_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_vpt_4_offset_virtual_4_offset_z_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_sb_ins_vpt_3_vel_ned_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_vpt_3_vel_ned_2_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->virtual_3_vel_ned_d << 0) & 0xff);
    dst_p[1] |= ((src_p->virtual_3_vel_ned_d >> 8) & 0xff);
    dst_p[2] |= ((src_p->virtual_3_vel_ned_d >> 16) & 0xff);
    dst_p[4] |= ((src_p->virtual_3_heading << 0) & 0xff);
    dst_p[5] |= ((src_p->virtual_3_heading >> 8) & 0xff);
    dst_p[6] |= ((src_p->virtual_3_slip << 0) & 0xff);
    dst_p[7] |= ((src_p->virtual_3_slip >> 8) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_vpt_3_vel_ned_2_decode(
    struct vehicle_rt_sb_ins_vpt_3_vel_ned_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->virtual_3_vel_ned_d |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->virtual_3_vel_ned_d |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->virtual_3_vel_ned_d |= ((uint32_t)(src_p[2] & 0xff) << 16);

    if (dst_p->virtual_3_vel_ned_d & (1 << 23)) {
        dst_p->virtual_3_vel_ned_d |= 0xff000000;
    }

    dst_p->virtual_3_heading |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->virtual_3_heading |= ((uint16_t)(src_p[5] & 0xff) << 8);
    dst_p->virtual_3_slip |= ((uint16_t)(src_p[6] & 0xff) >> 0);
    dst_p->virtual_3_slip |= ((uint16_t)(src_p[7] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_sb_ins_vpt_3_vel_ned_2_virtual_3_vel_ned_d_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

bool vehicle_rt_sb_ins_vpt_3_vel_ned_2_virtual_3_heading_is_in_range(int16_t value)
{
    return ((value >= -18000) && (value <= 18000));
}

bool vehicle_rt_sb_ins_vpt_3_vel_ned_2_virtual_3_slip_is_in_range(int16_t value)
{
    return ((value >= -18000) && (value <= 18000));
}

ssize_t vehicle_rt_sb_ins_vpt_3_vel_ned_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_vpt_3_vel_ned_1_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->virtual_3_vel_ned_n << 0) & 0xff);
    dst_p[1] |= ((src_p->virtual_3_vel_ned_n >> 8) & 0xff);
    dst_p[2] |= ((src_p->virtual_3_vel_ned_n >> 16) & 0xff);
    dst_p[4] |= ((src_p->virtual_3_vel_ned_e << 0) & 0xff);
    dst_p[5] |= ((src_p->virtual_3_vel_ned_e >> 8) & 0xff);
    dst_p[6] |= ((src_p->virtual_3_vel_ned_e >> 16) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_vpt_3_vel_ned_1_decode(
    struct vehicle_rt_sb_ins_vpt_3_vel_ned_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->virtual_3_vel_ned_n |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->virtual_3_vel_ned_n |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->virtual_3_vel_ned_n |= ((uint32_t)(src_p[2] & 0xff) << 16);

    if (dst_p->virtual_3_vel_ned_n & (1 << 23)) {
        dst_p->virtual_3_vel_ned_n |= 0xff000000;
    }

    dst_p->virtual_3_vel_ned_e |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->virtual_3_vel_ned_e |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->virtual_3_vel_ned_e |= ((uint32_t)(src_p[6] & 0xff) << 16);

    if (dst_p->virtual_3_vel_ned_e & (1 << 23)) {
        dst_p->virtual_3_vel_ned_e |= 0xff000000;
    }

    return (0);
}

bool vehicle_rt_sb_ins_vpt_3_vel_ned_1_virtual_3_vel_ned_n_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

bool vehicle_rt_sb_ins_vpt_3_vel_ned_1_virtual_3_vel_ned_e_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

ssize_t vehicle_rt_sb_ins_vpt_3_offset_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_vpt_3_offset_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->virtual_3_offset_x << 0) & 0xff);
    dst_p[1] |= ((src_p->virtual_3_offset_x >> 8) & 0xff);
    dst_p[2] |= ((src_p->virtual_3_offset_y << 0) & 0xff);
    dst_p[3] |= ((src_p->virtual_3_offset_y >> 8) & 0xff);
    dst_p[4] |= ((src_p->virtual_3_offset_z << 0) & 0xff);
    dst_p[5] |= ((src_p->virtual_3_offset_z >> 8) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_vpt_3_offset_decode(
    struct vehicle_rt_sb_ins_vpt_3_offset_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->virtual_3_offset_x |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->virtual_3_offset_x |= ((uint16_t)(src_p[1] & 0xff) << 8);
    dst_p->virtual_3_offset_y |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->virtual_3_offset_y |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->virtual_3_offset_z |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->virtual_3_offset_z |= ((uint16_t)(src_p[5] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_sb_ins_vpt_3_offset_virtual_3_offset_x_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_vpt_3_offset_virtual_3_offset_y_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_vpt_3_offset_virtual_3_offset_z_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_sb_ins_vpt_2_vel_ned_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_vpt_2_vel_ned_2_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->virtual_2_vel_ned_d << 0) & 0xff);
    dst_p[1] |= ((src_p->virtual_2_vel_ned_d >> 8) & 0xff);
    dst_p[2] |= ((src_p->virtual_2_vel_ned_d >> 16) & 0xff);
    dst_p[4] |= ((src_p->virtual_2_heading << 0) & 0xff);
    dst_p[5] |= ((src_p->virtual_2_heading >> 8) & 0xff);
    dst_p[6] |= ((src_p->virtual_2_slip << 0) & 0xff);
    dst_p[7] |= ((src_p->virtual_2_slip >> 8) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_vpt_2_vel_ned_2_decode(
    struct vehicle_rt_sb_ins_vpt_2_vel_ned_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->virtual_2_vel_ned_d |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->virtual_2_vel_ned_d |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->virtual_2_vel_ned_d |= ((uint32_t)(src_p[2] & 0xff) << 16);

    if (dst_p->virtual_2_vel_ned_d & (1 << 23)) {
        dst_p->virtual_2_vel_ned_d |= 0xff000000;
    }

    dst_p->virtual_2_heading |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->virtual_2_heading |= ((uint16_t)(src_p[5] & 0xff) << 8);
    dst_p->virtual_2_slip |= ((uint16_t)(src_p[6] & 0xff) >> 0);
    dst_p->virtual_2_slip |= ((uint16_t)(src_p[7] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_sb_ins_vpt_2_vel_ned_2_virtual_2_vel_ned_d_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

bool vehicle_rt_sb_ins_vpt_2_vel_ned_2_virtual_2_heading_is_in_range(int16_t value)
{
    return ((value >= -18000) && (value <= 18000));
}

bool vehicle_rt_sb_ins_vpt_2_vel_ned_2_virtual_2_slip_is_in_range(int16_t value)
{
    return ((value >= -18000) && (value <= 18000));
}

ssize_t vehicle_rt_sb_ins_vpt_2_vel_ned_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_vpt_2_vel_ned_1_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->virtual_2_vel_ned_n << 0) & 0xff);
    dst_p[1] |= ((src_p->virtual_2_vel_ned_n >> 8) & 0xff);
    dst_p[2] |= ((src_p->virtual_2_vel_ned_n >> 16) & 0xff);
    dst_p[4] |= ((src_p->virtual_2_vel_ned_e << 0) & 0xff);
    dst_p[5] |= ((src_p->virtual_2_vel_ned_e >> 8) & 0xff);
    dst_p[6] |= ((src_p->virtual_2_vel_ned_e >> 16) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_vpt_2_vel_ned_1_decode(
    struct vehicle_rt_sb_ins_vpt_2_vel_ned_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->virtual_2_vel_ned_n |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->virtual_2_vel_ned_n |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->virtual_2_vel_ned_n |= ((uint32_t)(src_p[2] & 0xff) << 16);

    if (dst_p->virtual_2_vel_ned_n & (1 << 23)) {
        dst_p->virtual_2_vel_ned_n |= 0xff000000;
    }

    dst_p->virtual_2_vel_ned_e |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->virtual_2_vel_ned_e |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->virtual_2_vel_ned_e |= ((uint32_t)(src_p[6] & 0xff) << 16);

    if (dst_p->virtual_2_vel_ned_e & (1 << 23)) {
        dst_p->virtual_2_vel_ned_e |= 0xff000000;
    }

    return (0);
}

bool vehicle_rt_sb_ins_vpt_2_vel_ned_1_virtual_2_vel_ned_n_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

bool vehicle_rt_sb_ins_vpt_2_vel_ned_1_virtual_2_vel_ned_e_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

ssize_t vehicle_rt_sb_ins_vpt_2_offset_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_vpt_2_offset_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->virtual_2_offset_x << 0) & 0xff);
    dst_p[1] |= ((src_p->virtual_2_offset_x >> 8) & 0xff);
    dst_p[2] |= ((src_p->virtual_2_offset_y << 0) & 0xff);
    dst_p[3] |= ((src_p->virtual_2_offset_y >> 8) & 0xff);
    dst_p[4] |= ((src_p->virtual_2_offset_z << 0) & 0xff);
    dst_p[5] |= ((src_p->virtual_2_offset_z >> 8) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_vpt_2_offset_decode(
    struct vehicle_rt_sb_ins_vpt_2_offset_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->virtual_2_offset_x |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->virtual_2_offset_x |= ((uint16_t)(src_p[1] & 0xff) << 8);
    dst_p->virtual_2_offset_y |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->virtual_2_offset_y |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->virtual_2_offset_z |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->virtual_2_offset_z |= ((uint16_t)(src_p[5] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_sb_ins_vpt_2_offset_virtual_2_offset_x_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_vpt_2_offset_virtual_2_offset_y_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_vpt_2_offset_virtual_2_offset_z_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_sb_ins_vpt_1_vel_ned_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_vpt_1_vel_ned_2_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->virtual_1_vel_ned_d << 0) & 0xff);
    dst_p[1] |= ((src_p->virtual_1_vel_ned_d >> 8) & 0xff);
    dst_p[2] |= ((src_p->virtual_1_vel_ned_d >> 16) & 0xff);
    dst_p[4] |= ((src_p->virtual_1_heading << 0) & 0xff);
    dst_p[5] |= ((src_p->virtual_1_heading >> 8) & 0xff);
    dst_p[6] |= ((src_p->virtual_1_slip << 0) & 0xff);
    dst_p[7] |= ((src_p->virtual_1_slip >> 8) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_vpt_1_vel_ned_2_decode(
    struct vehicle_rt_sb_ins_vpt_1_vel_ned_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->virtual_1_vel_ned_d |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->virtual_1_vel_ned_d |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->virtual_1_vel_ned_d |= ((uint32_t)(src_p[2] & 0xff) << 16);

    if (dst_p->virtual_1_vel_ned_d & (1 << 23)) {
        dst_p->virtual_1_vel_ned_d |= 0xff000000;
    }

    dst_p->virtual_1_heading |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->virtual_1_heading |= ((uint16_t)(src_p[5] & 0xff) << 8);
    dst_p->virtual_1_slip |= ((uint16_t)(src_p[6] & 0xff) >> 0);
    dst_p->virtual_1_slip |= ((uint16_t)(src_p[7] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_sb_ins_vpt_1_vel_ned_2_virtual_1_vel_ned_d_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

bool vehicle_rt_sb_ins_vpt_1_vel_ned_2_virtual_1_heading_is_in_range(int16_t value)
{
    return ((value >= -18000) && (value <= 18000));
}

bool vehicle_rt_sb_ins_vpt_1_vel_ned_2_virtual_1_slip_is_in_range(int16_t value)
{
    return ((value >= -18000) && (value <= 18000));
}

ssize_t vehicle_rt_sb_ins_vpt_1_vel_ned_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_vpt_1_vel_ned_1_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->virtual_1_vel_ned_n << 0) & 0xff);
    dst_p[1] |= ((src_p->virtual_1_vel_ned_n >> 8) & 0xff);
    dst_p[2] |= ((src_p->virtual_1_vel_ned_n >> 16) & 0xff);
    dst_p[4] |= ((src_p->virtual_1_vel_ned_e << 0) & 0xff);
    dst_p[5] |= ((src_p->virtual_1_vel_ned_e >> 8) & 0xff);
    dst_p[6] |= ((src_p->virtual_1_vel_ned_e >> 16) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_vpt_1_vel_ned_1_decode(
    struct vehicle_rt_sb_ins_vpt_1_vel_ned_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->virtual_1_vel_ned_n |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->virtual_1_vel_ned_n |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->virtual_1_vel_ned_n |= ((uint32_t)(src_p[2] & 0xff) << 16);

    if (dst_p->virtual_1_vel_ned_n & (1 << 23)) {
        dst_p->virtual_1_vel_ned_n |= 0xff000000;
    }

    dst_p->virtual_1_vel_ned_e |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->virtual_1_vel_ned_e |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->virtual_1_vel_ned_e |= ((uint32_t)(src_p[6] & 0xff) << 16);

    if (dst_p->virtual_1_vel_ned_e & (1 << 23)) {
        dst_p->virtual_1_vel_ned_e |= 0xff000000;
    }

    return (0);
}

bool vehicle_rt_sb_ins_vpt_1_vel_ned_1_virtual_1_vel_ned_n_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

bool vehicle_rt_sb_ins_vpt_1_vel_ned_1_virtual_1_vel_ned_e_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

ssize_t vehicle_rt_sb_ins_vpt_1_offset_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_vpt_1_offset_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->virtual_1_offset_x << 0) & 0xff);
    dst_p[1] |= ((src_p->virtual_1_offset_x >> 8) & 0xff);
    dst_p[2] |= ((src_p->virtual_1_offset_y << 0) & 0xff);
    dst_p[3] |= ((src_p->virtual_1_offset_y >> 8) & 0xff);
    dst_p[4] |= ((src_p->virtual_1_offset_z << 0) & 0xff);
    dst_p[5] |= ((src_p->virtual_1_offset_z >> 8) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_vpt_1_offset_decode(
    struct vehicle_rt_sb_ins_vpt_1_offset_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->virtual_1_offset_x |= ((uint16_t)(src_p[0] & 0xff) >> 0);
    dst_p->virtual_1_offset_x |= ((uint16_t)(src_p[1] & 0xff) << 8);
    dst_p->virtual_1_offset_y |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->virtual_1_offset_y |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->virtual_1_offset_z |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->virtual_1_offset_z |= ((uint16_t)(src_p[5] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_sb_ins_vpt_1_offset_virtual_1_offset_x_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_vpt_1_offset_virtual_1_offset_y_is_in_range(int16_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_vpt_1_offset_virtual_1_offset_z_is_in_range(int16_t value)
{
    return (true);
}

ssize_t vehicle_rt_sb_ins_slip_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_slip_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_ins_slip << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_ins_squat << 1) & 0x02);
    dst_p[1] |= ((src_p->accuracy_ins_slip << 0) & 0xff);
    dst_p[2] |= ((src_p->ins_slip << 0) & 0xff);
    dst_p[3] |= ((src_p->ins_slip >> 8) & 0xff);
    dst_p[4] |= ((src_p->accuracy_ins_squat << 0) & 0xff);
    dst_p[5] |= ((src_p->ins_squat << 0) & 0xff);
    dst_p[6] |= ((src_p->ins_squat >> 8) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_slip_decode(
    struct vehicle_rt_sb_ins_slip_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_ins_slip |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_ins_squat |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->accuracy_ins_slip |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->ins_slip |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->ins_slip |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->accuracy_ins_squat |= ((uint8_t)(src_p[4] & 0xff) >> 0);
    dst_p->ins_squat |= ((uint16_t)(src_p[5] & 0xff) >> 0);
    dst_p->ins_squat |= ((uint16_t)(src_p[6] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_sb_ins_slip_validity_ins_slip_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_slip_validity_ins_squat_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_slip_accuracy_ins_slip_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_slip_ins_slip_is_in_range(int16_t value)
{
    return ((value >= -36000) && (value <= 36000));
}

bool vehicle_rt_sb_ins_slip_accuracy_ins_squat_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_slip_ins_squat_is_in_range(int16_t value)
{
    return ((value >= -36000) && (value <= 36000));
}

ssize_t vehicle_rt_sb_ins_vel_ecef_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_vel_ecef_2_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_ins_vel_ecef_y << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_ins_vel_ecef_z << 1) & 0x02);
    dst_p[1] |= ((src_p->ins_vel_ecef_y << 0) & 0xff);
    dst_p[2] |= ((src_p->ins_vel_ecef_y >> 8) & 0xff);
    dst_p[3] |= ((src_p->ins_vel_ecef_y >> 16) & 0xff);
    dst_p[4] |= ((src_p->ins_vel_ecef_z << 0) & 0xff);
    dst_p[5] |= ((src_p->ins_vel_ecef_z >> 8) & 0xff);
    dst_p[6] |= ((src_p->ins_vel_ecef_z >> 16) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_vel_ecef_2_decode(
    struct vehicle_rt_sb_ins_vel_ecef_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_ins_vel_ecef_y |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_ins_vel_ecef_z |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->ins_vel_ecef_y |= ((uint32_t)(src_p[1] & 0xff) >> 0);
    dst_p->ins_vel_ecef_y |= ((uint32_t)(src_p[2] & 0xff) << 8);
    dst_p->ins_vel_ecef_y |= ((uint32_t)(src_p[3] & 0xff) << 16);

    if (dst_p->ins_vel_ecef_y & (1 << 23)) {
        dst_p->ins_vel_ecef_y |= 0xff000000;
    }

    dst_p->ins_vel_ecef_z |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->ins_vel_ecef_z |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->ins_vel_ecef_z |= ((uint32_t)(src_p[6] & 0xff) << 16);

    if (dst_p->ins_vel_ecef_z & (1 << 23)) {
        dst_p->ins_vel_ecef_z |= 0xff000000;
    }

    return (0);
}

bool vehicle_rt_sb_ins_vel_ecef_2_validity_ins_vel_ecef_y_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_vel_ecef_2_validity_ins_vel_ecef_z_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_vel_ecef_2_ins_vel_ecef_y_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

bool vehicle_rt_sb_ins_vel_ecef_2_ins_vel_ecef_z_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

ssize_t vehicle_rt_sb_ins_vel_ecef_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_vel_ecef_1_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_ins_vel_ecef_x << 0) & 0x01);
    dst_p[1] |= ((src_p->accuracy_ins_vel_ecef_x << 0) & 0xff);
    dst_p[2] |= ((src_p->accuracy_ins_vel_ecef_y << 0) & 0xff);
    dst_p[3] |= ((src_p->accuracy_ins_vel_ecef_z << 0) & 0xff);
    dst_p[4] |= ((src_p->ins_vel_ecef_x << 0) & 0xff);
    dst_p[5] |= ((src_p->ins_vel_ecef_x >> 8) & 0xff);
    dst_p[6] |= ((src_p->ins_vel_ecef_x >> 16) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_vel_ecef_1_decode(
    struct vehicle_rt_sb_ins_vel_ecef_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_ins_vel_ecef_x |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->accuracy_ins_vel_ecef_x |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->accuracy_ins_vel_ecef_y |= ((uint8_t)(src_p[2] & 0xff) >> 0);
    dst_p->accuracy_ins_vel_ecef_z |= ((uint8_t)(src_p[3] & 0xff) >> 0);
    dst_p->ins_vel_ecef_x |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->ins_vel_ecef_x |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->ins_vel_ecef_x |= ((uint32_t)(src_p[6] & 0xff) << 16);

    if (dst_p->ins_vel_ecef_x & (1 << 23)) {
        dst_p->ins_vel_ecef_x |= 0xff000000;
    }

    return (0);
}

bool vehicle_rt_sb_ins_vel_ecef_1_validity_ins_vel_ecef_x_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_vel_ecef_1_accuracy_ins_vel_ecef_x_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_vel_ecef_1_accuracy_ins_vel_ecef_y_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_vel_ecef_1_accuracy_ins_vel_ecef_z_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_vel_ecef_1_ins_vel_ecef_x_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

ssize_t vehicle_rt_sb_ins_vel_ned_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_vel_ned_2_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_ins_vel_ned_d << 0) & 0x01);
    dst_p[1] |= ((src_p->accuracy_ins_vel_d << 0) & 0xff);
    dst_p[2] |= ((src_p->ins_vel_ned_d << 0) & 0xff);
    dst_p[3] |= ((src_p->ins_vel_ned_d >> 8) & 0xff);
    dst_p[4] |= ((src_p->ins_vel_ned_d >> 16) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_vel_ned_2_decode(
    struct vehicle_rt_sb_ins_vel_ned_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_ins_vel_ned_d |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->accuracy_ins_vel_d |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->ins_vel_ned_d |= ((uint32_t)(src_p[2] & 0xff) >> 0);
    dst_p->ins_vel_ned_d |= ((uint32_t)(src_p[3] & 0xff) << 8);
    dst_p->ins_vel_ned_d |= ((uint32_t)(src_p[4] & 0xff) << 16);

    if (dst_p->ins_vel_ned_d & (1 << 23)) {
        dst_p->ins_vel_ned_d |= 0xff000000;
    }

    return (0);
}

bool vehicle_rt_sb_ins_vel_ned_2_validity_ins_vel_ned_d_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_vel_ned_2_accuracy_ins_vel_d_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_vel_ned_2_ins_vel_ned_d_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

ssize_t vehicle_rt_sb_ins_vel_ned_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_vel_ned_1_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_ins_vel_ned_n << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_ins_vel_ned_e << 1) & 0x02);
    dst_p[1] |= ((src_p->accuracy_ins_vel_ne << 0) & 0xff);
    dst_p[2] |= ((src_p->ins_vel_ned_n << 0) & 0xff);
    dst_p[3] |= ((src_p->ins_vel_ned_n >> 8) & 0xff);
    dst_p[4] |= ((src_p->ins_vel_ned_n >> 16) & 0xff);
    dst_p[5] |= ((src_p->ins_vel_ned_e << 0) & 0xff);
    dst_p[6] |= ((src_p->ins_vel_ned_e >> 8) & 0xff);
    dst_p[7] |= ((src_p->ins_vel_ned_e >> 16) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_vel_ned_1_decode(
    struct vehicle_rt_sb_ins_vel_ned_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_ins_vel_ned_n |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_ins_vel_ned_e |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->accuracy_ins_vel_ne |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->ins_vel_ned_n |= ((uint32_t)(src_p[2] & 0xff) >> 0);
    dst_p->ins_vel_ned_n |= ((uint32_t)(src_p[3] & 0xff) << 8);
    dst_p->ins_vel_ned_n |= ((uint32_t)(src_p[4] & 0xff) << 16);

    if (dst_p->ins_vel_ned_n & (1 << 23)) {
        dst_p->ins_vel_ned_n |= 0xff000000;
    }

    dst_p->ins_vel_ned_e |= ((uint32_t)(src_p[5] & 0xff) >> 0);
    dst_p->ins_vel_ned_e |= ((uint32_t)(src_p[6] & 0xff) << 8);
    dst_p->ins_vel_ned_e |= ((uint32_t)(src_p[7] & 0xff) << 16);

    if (dst_p->ins_vel_ned_e & (1 << 23)) {
        dst_p->ins_vel_ned_e |= 0xff000000;
    }

    return (0);
}

bool vehicle_rt_sb_ins_vel_ned_1_validity_ins_vel_ned_n_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_vel_ned_1_validity_ins_vel_ned_e_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_vel_ned_1_accuracy_ins_vel_ne_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_vel_ned_1_ins_vel_ned_n_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

bool vehicle_rt_sb_ins_vel_ned_1_ins_vel_ned_e_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

ssize_t vehicle_rt_sb_ins_pos_ecef_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_pos_ecef_2_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->ins_pos_ecef_y << 0) & 0xff);
    dst_p[1] |= ((src_p->ins_pos_ecef_y >> 8) & 0xff);
    dst_p[2] |= ((src_p->ins_pos_ecef_y >> 16) & 0xff);
    dst_p[3] |= ((src_p->ins_pos_ecef_y >> 24) & 0xff);
    dst_p[4] |= ((src_p->ins_pos_ecef_z << 0) & 0xff);
    dst_p[5] |= ((src_p->ins_pos_ecef_z >> 8) & 0xff);
    dst_p[6] |= ((src_p->ins_pos_ecef_z >> 16) & 0xff);
    dst_p[7] |= ((src_p->ins_pos_ecef_z >> 24) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_pos_ecef_2_decode(
    struct vehicle_rt_sb_ins_pos_ecef_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ins_pos_ecef_y |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->ins_pos_ecef_y |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->ins_pos_ecef_y |= ((uint32_t)(src_p[2] & 0xff) << 16);
    dst_p->ins_pos_ecef_y |= ((uint32_t)(src_p[3] & 0xff) << 24);
    dst_p->ins_pos_ecef_z |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->ins_pos_ecef_z |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->ins_pos_ecef_z |= ((uint32_t)(src_p[6] & 0xff) << 16);
    dst_p->ins_pos_ecef_z |= ((uint32_t)(src_p[7] & 0xff) << 24);

    return (0);
}

bool vehicle_rt_sb_ins_pos_ecef_2_ins_pos_ecef_y_is_in_range(int32_t value)
{
    return ((value >= -1000000000) && (value <= 1000000000));
}

bool vehicle_rt_sb_ins_pos_ecef_2_ins_pos_ecef_z_is_in_range(int32_t value)
{
    return ((value >= -1000000000) && (value <= 1000000000));
}

ssize_t vehicle_rt_sb_ins_pos_ecef_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_pos_ecef_1_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_ins_pos_ecef_x << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_ins_pos_ecef_y << 1) & 0x02);
    dst_p[0] |= ((src_p->validity_ins_pos_ecef_z << 2) & 0x04);
    dst_p[1] |= ((src_p->accuracy_ins_pos_ecef_x << 0) & 0xff);
    dst_p[2] |= ((src_p->accuracy_ins_pos_ecef_y << 0) & 0xff);
    dst_p[3] |= ((src_p->accuracy_ins_pos_ecef_z << 0) & 0xff);
    dst_p[4] |= ((src_p->ins_pos_ecef_x << 0) & 0xff);
    dst_p[5] |= ((src_p->ins_pos_ecef_x >> 8) & 0xff);
    dst_p[6] |= ((src_p->ins_pos_ecef_x >> 16) & 0xff);
    dst_p[7] |= ((src_p->ins_pos_ecef_x >> 24) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_pos_ecef_1_decode(
    struct vehicle_rt_sb_ins_pos_ecef_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_ins_pos_ecef_x |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_ins_pos_ecef_y |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->validity_ins_pos_ecef_z |= ((uint8_t)(src_p[0] & 0x04) >> 2);
    dst_p->accuracy_ins_pos_ecef_x |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->accuracy_ins_pos_ecef_y |= ((uint8_t)(src_p[2] & 0xff) >> 0);
    dst_p->accuracy_ins_pos_ecef_z |= ((uint8_t)(src_p[3] & 0xff) >> 0);
    dst_p->ins_pos_ecef_x |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->ins_pos_ecef_x |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->ins_pos_ecef_x |= ((uint32_t)(src_p[6] & 0xff) << 16);
    dst_p->ins_pos_ecef_x |= ((uint32_t)(src_p[7] & 0xff) << 24);

    return (0);
}

bool vehicle_rt_sb_ins_pos_ecef_1_validity_ins_pos_ecef_x_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_pos_ecef_1_validity_ins_pos_ecef_y_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_pos_ecef_1_validity_ins_pos_ecef_z_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_pos_ecef_1_accuracy_ins_pos_ecef_x_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_pos_ecef_1_accuracy_ins_pos_ecef_y_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_pos_ecef_1_accuracy_ins_pos_ecef_z_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_pos_ecef_1_ins_pos_ecef_x_is_in_range(int32_t value)
{
    return ((value >= -1000000000) && (value <= 1000000000));
}

ssize_t vehicle_rt_sb_ins_pos_llh_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_pos_llh_2_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->ins_pos_llh_longitude << 0) & 0xff);
    dst_p[1] |= ((src_p->ins_pos_llh_longitude >> 8) & 0xff);
    dst_p[2] |= ((src_p->ins_pos_llh_longitude >> 16) & 0xff);
    dst_p[3] |= ((src_p->ins_pos_llh_longitude >> 24) & 0xff);
    dst_p[4] |= ((src_p->ins_pos_llh_altitude << 0) & 0xff);
    dst_p[5] |= ((src_p->ins_pos_llh_altitude >> 8) & 0xff);
    dst_p[6] |= ((src_p->ins_pos_llh_altitude >> 16) & 0xff);
    dst_p[7] |= ((src_p->ins_pos_llh_altitude >> 24) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_pos_llh_2_decode(
    struct vehicle_rt_sb_ins_pos_llh_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ins_pos_llh_longitude |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->ins_pos_llh_longitude |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->ins_pos_llh_longitude |= ((uint32_t)(src_p[2] & 0xff) << 16);
    dst_p->ins_pos_llh_longitude |= ((uint32_t)(src_p[3] & 0xff) << 24);
    dst_p->ins_pos_llh_altitude |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->ins_pos_llh_altitude |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->ins_pos_llh_altitude |= ((uint32_t)(src_p[6] & 0xff) << 16);
    dst_p->ins_pos_llh_altitude |= ((uint32_t)(src_p[7] & 0xff) << 24);

    return (0);
}

bool vehicle_rt_sb_ins_pos_llh_2_ins_pos_llh_longitude_is_in_range(int32_t value)
{
    return ((value >= -1800000000) && (value <= 1800000000));
}

bool vehicle_rt_sb_ins_pos_llh_2_ins_pos_llh_altitude_is_in_range(int32_t value)
{
    return ((value >= -1000000) && (value <= 100000000));
}

ssize_t vehicle_rt_sb_ins_pos_llh_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_pos_llh_1_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_ins_pos_llh_latitude << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_ins_pos_llh_longitude << 1) & 0x02);
    dst_p[0] |= ((src_p->validity_ins_pos_llh_altitude << 2) & 0x04);
    dst_p[1] |= ((src_p->accuracy_ins_pos_llh_latitude << 0) & 0xff);
    dst_p[2] |= ((src_p->accuracy_ins_pos_llh_longitude << 0) & 0xff);
    dst_p[3] |= ((src_p->accuracy_ins_pos_llh_altitude << 0) & 0xff);
    dst_p[4] |= ((src_p->ins_pos_llh_latitude << 0) & 0xff);
    dst_p[5] |= ((src_p->ins_pos_llh_latitude >> 8) & 0xff);
    dst_p[6] |= ((src_p->ins_pos_llh_latitude >> 16) & 0xff);
    dst_p[7] |= ((src_p->ins_pos_llh_latitude >> 24) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_pos_llh_1_decode(
    struct vehicle_rt_sb_ins_pos_llh_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_ins_pos_llh_latitude |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_ins_pos_llh_longitude |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->validity_ins_pos_llh_altitude |= ((uint8_t)(src_p[0] & 0x04) >> 2);
    dst_p->accuracy_ins_pos_llh_latitude |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->accuracy_ins_pos_llh_longitude |= ((uint8_t)(src_p[2] & 0xff) >> 0);
    dst_p->accuracy_ins_pos_llh_altitude |= ((uint8_t)(src_p[3] & 0xff) >> 0);
    dst_p->ins_pos_llh_latitude |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->ins_pos_llh_latitude |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->ins_pos_llh_latitude |= ((uint32_t)(src_p[6] & 0xff) << 16);
    dst_p->ins_pos_llh_latitude |= ((uint32_t)(src_p[7] & 0xff) << 24);

    return (0);
}

bool vehicle_rt_sb_ins_pos_llh_1_validity_ins_pos_llh_latitude_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_pos_llh_1_validity_ins_pos_llh_longitude_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_pos_llh_1_validity_ins_pos_llh_altitude_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_pos_llh_1_accuracy_ins_pos_llh_latitude_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_pos_llh_1_accuracy_ins_pos_llh_longitude_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_pos_llh_1_accuracy_ins_pos_llh_altitude_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_pos_llh_1_ins_pos_llh_latitude_is_in_range(int32_t value)
{
    return ((value >= -900000000) && (value <= 900000000));
}

ssize_t vehicle_rt_sb_ins_heading_gradient_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_heading_gradient_2_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_ins_heading << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_ins_gradient << 1) & 0x02);
    dst_p[1] |= ((src_p->accuracy_ins_heading << 0) & 0xff);
    dst_p[2] |= ((src_p->ins_heading_2 << 0) & 0xff);
    dst_p[3] |= ((src_p->ins_heading_2 >> 8) & 0xff);
    dst_p[4] |= ((src_p->accuracy_ins_gradient << 0) & 0xff);
    dst_p[5] |= ((src_p->ins_gradient << 0) & 0xff);
    dst_p[6] |= ((src_p->ins_gradient >> 8) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_heading_gradient_2_decode(
    struct vehicle_rt_sb_ins_heading_gradient_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_ins_heading |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_ins_gradient |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->accuracy_ins_heading |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->ins_heading_2 |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->ins_heading_2 |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->accuracy_ins_gradient |= ((uint8_t)(src_p[4] & 0xff) >> 0);
    dst_p->ins_gradient |= ((uint16_t)(src_p[5] & 0xff) >> 0);
    dst_p->ins_gradient |= ((uint16_t)(src_p[6] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_sb_ins_heading_gradient_2_validity_ins_heading_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_heading_gradient_2_validity_ins_gradient_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_heading_gradient_2_accuracy_ins_heading_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_heading_gradient_2_ins_heading_2_is_in_range(uint16_t value)
{
    return (value <= 36000u);
}

bool vehicle_rt_sb_ins_heading_gradient_2_accuracy_ins_gradient_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_heading_gradient_2_ins_gradient_is_in_range(int16_t value)
{
    return ((value >= -9000) && (value <= 9000));
}

ssize_t vehicle_rt_sb_ins_heading_gradient_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_heading_gradient_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_ins_heading << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_ins_gradient << 1) & 0x02);
    dst_p[1] |= ((src_p->accuracy_ins_heading << 0) & 0xff);
    dst_p[2] |= ((src_p->ins_heading << 0) & 0xff);
    dst_p[3] |= ((src_p->ins_heading >> 8) & 0xff);
    dst_p[4] |= ((src_p->accuracy_ins_gradient << 0) & 0xff);
    dst_p[5] |= ((src_p->ins_gradient << 0) & 0xff);
    dst_p[6] |= ((src_p->ins_gradient >> 8) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_heading_gradient_decode(
    struct vehicle_rt_sb_ins_heading_gradient_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_ins_heading |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_ins_gradient |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->accuracy_ins_heading |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->ins_heading |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->ins_heading |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->accuracy_ins_gradient |= ((uint8_t)(src_p[4] & 0xff) >> 0);
    dst_p->ins_gradient |= ((uint16_t)(src_p[5] & 0xff) >> 0);
    dst_p->ins_gradient |= ((uint16_t)(src_p[6] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_sb_ins_heading_gradient_validity_ins_heading_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_heading_gradient_validity_ins_gradient_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_heading_gradient_accuracy_ins_heading_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_heading_gradient_ins_heading_is_in_range(int16_t value)
{
    return ((value >= -18000) && (value <= 18000));
}

bool vehicle_rt_sb_ins_heading_gradient_accuracy_ins_gradient_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_heading_gradient_ins_gradient_is_in_range(int16_t value)
{
    return ((value >= -9000) && (value <= 9000));
}

ssize_t vehicle_rt_sb_ins_status_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_status_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->ins_status << 0) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_status_decode(
    struct vehicle_rt_sb_ins_status_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->ins_status |= ((uint8_t)(src_p[0] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_sb_ins_status_ins_status_is_in_range(uint8_t value)
{
    return (true);
}

ssize_t vehicle_rt_sb_ins_attitude_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_ins_attitude_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_yaw << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_pitch << 1) & 0x02);
    dst_p[0] |= ((src_p->validity_roll << 2) & 0x04);
    dst_p[1] |= ((src_p->accuracy_attitude << 0) & 0xff);
    dst_p[2] |= ((src_p->attitude_yaw << 0) & 0xff);
    dst_p[3] |= ((src_p->attitude_yaw >> 8) & 0xff);
    dst_p[4] |= ((src_p->attitude_pitch << 0) & 0xff);
    dst_p[5] |= ((src_p->attitude_pitch >> 8) & 0xff);
    dst_p[6] |= ((src_p->attitude_roll << 0) & 0xff);
    dst_p[7] |= ((src_p->attitude_roll >> 8) & 0xff);

    return (8);
}

int vehicle_rt_sb_ins_attitude_decode(
    struct vehicle_rt_sb_ins_attitude_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_yaw |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_pitch |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->validity_roll |= ((uint8_t)(src_p[0] & 0x04) >> 2);
    dst_p->accuracy_attitude |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->attitude_yaw |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->attitude_yaw |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->attitude_pitch |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->attitude_pitch |= ((uint16_t)(src_p[5] & 0xff) << 8);
    dst_p->attitude_roll |= ((uint16_t)(src_p[6] & 0xff) >> 0);
    dst_p->attitude_roll |= ((uint16_t)(src_p[7] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_sb_ins_attitude_validity_yaw_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_attitude_validity_pitch_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_attitude_validity_roll_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_ins_attitude_accuracy_attitude_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_ins_attitude_attitude_yaw_is_in_range(int16_t value)
{
    return ((value >= -36000) && (value <= 36000));
}

bool vehicle_rt_sb_ins_attitude_attitude_pitch_is_in_range(int16_t value)
{
    return ((value >= -36000) && (value <= 36000));
}

bool vehicle_rt_sb_ins_attitude_attitude_roll_is_in_range(int16_t value)
{
    return ((value >= -36000) && (value <= 36000));
}

ssize_t vehicle_rt_sb_output_status_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_output_status_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_status_timestamp << 0) & 0x01);
    dst_p[1] |= ((src_p->status_analogue_1 << 0) & 0x01);
    dst_p[1] |= ((src_p->status_analogue_2 << 1) & 0x02);
    dst_p[1] |= ((src_p->status_analogue_3 << 2) & 0x04);
    dst_p[1] |= ((src_p->status_analogue_4 << 3) & 0x08);
    dst_p[1] |= ((src_p->status_pulse_output << 4) & 0x10);
    dst_p[1] |= ((src_p->status_serial_output_1 << 5) & 0x20);
    dst_p[1] |= ((src_p->status_serial_output_2 << 6) & 0x40);
    dst_p[1] |= ((src_p->status_trigger << 7) & 0x80);
    dst_p[4] |= ((src_p->gps_time << 0) & 0xff);
    dst_p[5] |= ((src_p->gps_time >> 8) & 0xff);
    dst_p[6] |= ((src_p->gps_time >> 16) & 0xff);
    dst_p[7] |= ((src_p->gps_time >> 24) & 0xff);

    return (8);
}

int vehicle_rt_sb_output_status_decode(
    struct vehicle_rt_sb_output_status_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_status_timestamp |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->status_analogue_1 |= ((uint8_t)(src_p[1] & 0x01) >> 0);
    dst_p->status_analogue_2 |= ((uint8_t)(src_p[1] & 0x02) >> 1);
    dst_p->status_analogue_3 |= ((uint8_t)(src_p[1] & 0x04) >> 2);
    dst_p->status_analogue_4 |= ((uint8_t)(src_p[1] & 0x08) >> 3);
    dst_p->status_pulse_output |= ((uint8_t)(src_p[1] & 0x10) >> 4);
    dst_p->status_serial_output_1 |= ((uint8_t)(src_p[1] & 0x20) >> 5);
    dst_p->status_serial_output_2 |= ((uint8_t)(src_p[1] & 0x40) >> 6);
    dst_p->status_trigger |= ((uint8_t)(src_p[1] & 0x80) >> 7);
    dst_p->gps_time |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->gps_time |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->gps_time |= ((uint32_t)(src_p[6] & 0xff) << 16);
    dst_p->gps_time |= ((uint32_t)(src_p[7] & 0xff) << 24);

    return (0);
}

bool vehicle_rt_sb_output_status_validity_status_timestamp_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_output_status_status_analogue_1_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_output_status_status_analogue_2_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_output_status_status_analogue_3_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_output_status_status_analogue_4_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_output_status_status_pulse_output_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_output_status_status_serial_output_1_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_output_status_status_serial_output_2_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_output_status_status_trigger_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_output_status_gps_time_is_in_range(uint32_t value)
{
    return (value <= 604800000u);
}

ssize_t vehicle_rt_sb_gps_heading_gradient_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_gps_heading_gradient_2_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_gps_heading << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_gps_gradient << 1) & 0x02);
    dst_p[1] |= ((src_p->accuracy_gps_heading << 0) & 0xff);
    dst_p[2] |= ((src_p->gps_heading_2 << 0) & 0xff);
    dst_p[3] |= ((src_p->gps_heading_2 >> 8) & 0xff);
    dst_p[4] |= ((src_p->accuracy_gps_gradient << 0) & 0xff);
    dst_p[5] |= ((src_p->gps_gradient << 0) & 0xff);
    dst_p[6] |= ((src_p->gps_gradient >> 8) & 0xff);

    return (8);
}

int vehicle_rt_sb_gps_heading_gradient_2_decode(
    struct vehicle_rt_sb_gps_heading_gradient_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_gps_heading |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_gps_gradient |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->accuracy_gps_heading |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->gps_heading_2 |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->gps_heading_2 |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->accuracy_gps_gradient |= ((uint8_t)(src_p[4] & 0xff) >> 0);
    dst_p->gps_gradient |= ((uint16_t)(src_p[5] & 0xff) >> 0);
    dst_p->gps_gradient |= ((uint16_t)(src_p[6] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_sb_gps_heading_gradient_2_validity_gps_heading_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gps_heading_gradient_2_validity_gps_gradient_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gps_heading_gradient_2_accuracy_gps_heading_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gps_heading_gradient_2_gps_heading_2_is_in_range(uint16_t value)
{
    return (value <= 36000u);
}

bool vehicle_rt_sb_gps_heading_gradient_2_accuracy_gps_gradient_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gps_heading_gradient_2_gps_gradient_is_in_range(int16_t value)
{
    return ((value >= -9000) && (value <= 9000));
}

ssize_t vehicle_rt_sb_cumulative_distance_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_cumulative_distance_2_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_cumulative_time << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_cumulative_distance << 1) & 0x02);
    dst_p[1] |= ((src_p->cumulative_time << 0) & 0xff);
    dst_p[2] |= ((src_p->cumulative_time >> 8) & 0xff);
    dst_p[3] |= ((src_p->cumulative_time >> 16) & 0xff);
    dst_p[4] |= ((src_p->cumulative_distance << 0) & 0xff);
    dst_p[5] |= ((src_p->cumulative_distance >> 8) & 0xff);
    dst_p[6] |= ((src_p->cumulative_distance >> 16) & 0xff);
    dst_p[7] |= ((src_p->cumulative_distance >> 24) & 0xff);

    return (8);
}

int vehicle_rt_sb_cumulative_distance_2_decode(
    struct vehicle_rt_sb_cumulative_distance_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_cumulative_time |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_cumulative_distance |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->cumulative_time |= ((uint32_t)(src_p[1] & 0xff) >> 0);
    dst_p->cumulative_time |= ((uint32_t)(src_p[2] & 0xff) << 8);
    dst_p->cumulative_time |= ((uint32_t)(src_p[3] & 0xff) << 16);
    dst_p->cumulative_distance |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->cumulative_distance |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->cumulative_distance |= ((uint32_t)(src_p[6] & 0xff) << 16);
    dst_p->cumulative_distance |= ((uint32_t)(src_p[7] & 0xff) << 24);

    return (0);
}

bool vehicle_rt_sb_cumulative_distance_2_validity_cumulative_time_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_cumulative_distance_2_validity_cumulative_distance_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_cumulative_distance_2_cumulative_time_is_in_range(uint32_t value)
{
    return (value <= 16777200u);
}

bool vehicle_rt_sb_cumulative_distance_2_cumulative_distance_is_in_range(uint32_t value)
{
    return (value <= 4294967000u);
}

ssize_t vehicle_rt_sb_cumulative_distance_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_cumulative_distance_1_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_cumulative_time << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_cumulative_distance << 1) & 0x02);
    dst_p[1] |= ((src_p->cumulative_time << 0) & 0xff);
    dst_p[2] |= ((src_p->cumulative_time >> 8) & 0xff);
    dst_p[3] |= ((src_p->cumulative_time >> 16) & 0xff);
    dst_p[4] |= ((src_p->cumulative_distance << 0) & 0xff);
    dst_p[5] |= ((src_p->cumulative_distance >> 8) & 0xff);
    dst_p[6] |= ((src_p->cumulative_distance >> 16) & 0xff);
    dst_p[7] |= ((src_p->cumulative_distance >> 24) & 0xff);

    return (8);
}

int vehicle_rt_sb_cumulative_distance_1_decode(
    struct vehicle_rt_sb_cumulative_distance_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_cumulative_time |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_cumulative_distance |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->cumulative_time |= ((uint32_t)(src_p[1] & 0xff) >> 0);
    dst_p->cumulative_time |= ((uint32_t)(src_p[2] & 0xff) << 8);
    dst_p->cumulative_time |= ((uint32_t)(src_p[3] & 0xff) << 16);
    dst_p->cumulative_distance |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->cumulative_distance |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->cumulative_distance |= ((uint32_t)(src_p[6] & 0xff) << 16);
    dst_p->cumulative_distance |= ((uint32_t)(src_p[7] & 0xff) << 24);

    return (0);
}

bool vehicle_rt_sb_cumulative_distance_1_validity_cumulative_time_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_cumulative_distance_1_validity_cumulative_distance_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_cumulative_distance_1_cumulative_time_is_in_range(uint32_t value)
{
    return (value <= 16777200u);
}

bool vehicle_rt_sb_cumulative_distance_1_cumulative_distance_is_in_range(uint32_t value)
{
    return (value <= 4294967000u);
}

ssize_t vehicle_rt_sb_trigger_timestamp_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_trigger_timestamp_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_trigger_timestamp << 0) & 0x01);
    dst_p[1] |= ((src_p->accuracy_trigger_timestamp << 0) & 0xff);
    dst_p[2] |= ((src_p->trigger_number << 0) & 0x7f);
    dst_p[2] |= ((src_p->trigger_timestamp_type << 7) & 0x80);
    dst_p[3] |= ((src_p->gps_high_resolution_time << 0) & 0xff);
    dst_p[4] |= ((src_p->gps_high_resolution_time >> 8) & 0xff);
    dst_p[5] |= ((src_p->gps_high_resolution_time >> 16) & 0xff);
    dst_p[6] |= ((src_p->gps_high_resolution_time >> 24) & 0xff);
    dst_p[7] |= ((src_p->gps_high_resolution_time >> 32) & 0xff);

    return (8);
}

int vehicle_rt_sb_trigger_timestamp_decode(
    struct vehicle_rt_sb_trigger_timestamp_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_trigger_timestamp |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->accuracy_trigger_timestamp |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->trigger_number |= ((uint8_t)(src_p[2] & 0x7f) >> 0);
    dst_p->trigger_timestamp_type |= ((uint8_t)(src_p[2] & 0x80) >> 7);
    dst_p->gps_high_resolution_time |= ((uint64_t)(src_p[3] & 0xff) >> 0);
    dst_p->gps_high_resolution_time |= ((uint64_t)(src_p[4] & 0xff) << 8);
    dst_p->gps_high_resolution_time |= ((uint64_t)(src_p[5] & 0xff) << 16);
    dst_p->gps_high_resolution_time |= ((uint64_t)(src_p[6] & 0xff) << 24);
    dst_p->gps_high_resolution_time |= ((uint64_t)(src_p[7] & 0xff) << 32);

    return (0);
}

bool vehicle_rt_sb_trigger_timestamp_validity_trigger_timestamp_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_trigger_timestamp_accuracy_trigger_timestamp_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_trigger_timestamp_trigger_number_is_in_range(uint8_t value)
{
    return ((value >= -1u) && (value <= 127u));
}

bool vehicle_rt_sb_trigger_timestamp_trigger_timestamp_type_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_trigger_timestamp_gps_high_resolution_time_is_in_range(uint64_t value)
{
    return (value <= 604800000000ull);
}

ssize_t vehicle_rt_imu06_gyro_rates_encode(
    uint8_t *dst_p,
    struct vehicle_rt_imu06_gyro_rates_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_gyro_rate_yaw << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_gyro_rate_pitch << 1) & 0x02);
    dst_p[0] |= ((src_p->validity_gyro_rate_roll << 2) & 0x04);
    dst_p[1] |= ((src_p->accuracy_gyro_rates << 0) & 0xff);
    dst_p[2] |= ((src_p->gyro_rate_yaw << 0) & 0xff);
    dst_p[3] |= ((src_p->gyro_rate_yaw >> 8) & 0xff);
    dst_p[4] |= ((src_p->gyro_rate_pitch << 0) & 0xff);
    dst_p[5] |= ((src_p->gyro_rate_pitch >> 8) & 0xff);
    dst_p[6] |= ((src_p->gyro_rate_roll << 0) & 0xff);
    dst_p[7] |= ((src_p->gyro_rate_roll >> 8) & 0xff);

    return (8);
}

int vehicle_rt_imu06_gyro_rates_decode(
    struct vehicle_rt_imu06_gyro_rates_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_gyro_rate_yaw |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_gyro_rate_pitch |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->validity_gyro_rate_roll |= ((uint8_t)(src_p[0] & 0x04) >> 2);
    dst_p->accuracy_gyro_rates |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->gyro_rate_yaw |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->gyro_rate_yaw |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->gyro_rate_pitch |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->gyro_rate_pitch |= ((uint16_t)(src_p[5] & 0xff) << 8);
    dst_p->gyro_rate_roll |= ((uint16_t)(src_p[6] & 0xff) >> 0);
    dst_p->gyro_rate_roll |= ((uint16_t)(src_p[7] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_imu06_gyro_rates_validity_gyro_rate_yaw_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_imu06_gyro_rates_validity_gyro_rate_pitch_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_imu06_gyro_rates_validity_gyro_rate_roll_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_imu06_gyro_rates_accuracy_gyro_rates_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_imu06_gyro_rates_gyro_rate_yaw_is_in_range(int16_t value)
{
    return ((value >= -32700) && (value <= 32700));
}

bool vehicle_rt_imu06_gyro_rates_gyro_rate_pitch_is_in_range(int16_t value)
{
    return ((value >= -32700) && (value <= 32700));
}

bool vehicle_rt_imu06_gyro_rates_gyro_rate_roll_is_in_range(int16_t value)
{
    return ((value >= -32700) && (value <= 32700));
}

ssize_t vehicle_rt_imu06_accel_encode(
    uint8_t *dst_p,
    struct vehicle_rt_imu06_accel_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_accel_longitudinal << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_accel_lateral << 1) & 0x02);
    dst_p[0] |= ((src_p->validity_accel_vertical << 2) & 0x04);
    dst_p[1] |= ((src_p->accuracy_accel << 0) & 0xff);
    dst_p[2] |= ((src_p->accel_longitudinal << 0) & 0xff);
    dst_p[3] |= ((src_p->accel_longitudinal >> 8) & 0xff);
    dst_p[4] |= ((src_p->accel_lateral << 0) & 0xff);
    dst_p[5] |= ((src_p->accel_lateral >> 8) & 0xff);
    dst_p[6] |= ((src_p->accel_vertical << 0) & 0xff);
    dst_p[7] |= ((src_p->accel_vertical >> 8) & 0xff);

    return (8);
}

int vehicle_rt_imu06_accel_decode(
    struct vehicle_rt_imu06_accel_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_accel_longitudinal |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_accel_lateral |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->validity_accel_vertical |= ((uint8_t)(src_p[0] & 0x04) >> 2);
    dst_p->accuracy_accel |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->accel_longitudinal |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->accel_longitudinal |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->accel_lateral |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->accel_lateral |= ((uint16_t)(src_p[5] & 0xff) << 8);
    dst_p->accel_vertical |= ((uint16_t)(src_p[6] & 0xff) >> 0);
    dst_p->accel_vertical |= ((uint16_t)(src_p[7] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_imu06_accel_validity_accel_longitudinal_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_imu06_accel_validity_accel_lateral_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_imu06_accel_validity_accel_vertical_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_imu06_accel_accuracy_accel_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_imu06_accel_accel_longitudinal_is_in_range(int16_t value)
{
    return ((value >= -65000) && (value <= 65000));
}

bool vehicle_rt_imu06_accel_accel_lateral_is_in_range(int16_t value)
{
    return ((value >= -65000) && (value <= 65000));
}

bool vehicle_rt_imu06_accel_accel_vertical_is_in_range(int16_t value)
{
    return ((value >= -65000) && (value <= 65000));
}

ssize_t vehicle_rt_sb_speed_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_speed_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_speed << 0) & 0x01);
    dst_p[1] |= ((src_p->accuracy_speed << 0) & 0xff);
    dst_p[2] |= ((src_p->speed << 0) & 0xff);
    dst_p[3] |= ((src_p->speed >> 8) & 0xff);
    dst_p[4] |= ((src_p->speed >> 16) & 0xff);
    dst_p[5] |= ((src_p->speed >> 24) & 0xff);

    return (8);
}

int vehicle_rt_sb_speed_decode(
    struct vehicle_rt_sb_speed_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_speed |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->accuracy_speed |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->speed |= ((uint32_t)(src_p[2] & 0xff) >> 0);
    dst_p->speed |= ((uint32_t)(src_p[3] & 0xff) << 8);
    dst_p->speed |= ((uint32_t)(src_p[4] & 0xff) << 16);
    dst_p->speed |= ((uint32_t)(src_p[5] & 0xff) << 24);

    return (0);
}

bool vehicle_rt_sb_speed_validity_speed_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_speed_accuracy_speed_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_speed_speed_is_in_range(int32_t value)
{
    return ((value >= -2000000000) && (value <= 2000000000));
}

ssize_t vehicle_rt_sb_rtk_slip_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_rtk_slip_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_rtk_slip << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_rtk_squat << 1) & 0x02);
    dst_p[0] |= ((src_p->validity_rtk_baseline << 2) & 0x04);
    dst_p[1] |= ((src_p->accuracy_rtk_baseline << 0) & 0xff);
    dst_p[2] |= ((src_p->rtk_slip << 0) & 0xff);
    dst_p[3] |= ((src_p->rtk_slip >> 8) & 0xff);
    dst_p[4] |= ((src_p->rtk_squat << 0) & 0xff);
    dst_p[5] |= ((src_p->rtk_squat >> 8) & 0xff);
    dst_p[6] |= ((src_p->rtk_baseline << 0) & 0xff);
    dst_p[7] |= ((src_p->rtk_baseline >> 8) & 0xff);

    return (8);
}

int vehicle_rt_sb_rtk_slip_decode(
    struct vehicle_rt_sb_rtk_slip_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_rtk_slip |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_rtk_squat |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->validity_rtk_baseline |= ((uint8_t)(src_p[0] & 0x04) >> 2);
    dst_p->accuracy_rtk_baseline |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->rtk_slip |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->rtk_slip |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->rtk_squat |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->rtk_squat |= ((uint16_t)(src_p[5] & 0xff) << 8);
    dst_p->rtk_baseline |= ((uint16_t)(src_p[6] & 0xff) >> 0);
    dst_p->rtk_baseline |= ((uint16_t)(src_p[7] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_sb_rtk_slip_validity_rtk_slip_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_rtk_slip_validity_rtk_squat_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_rtk_slip_validity_rtk_baseline_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_rtk_slip_accuracy_rtk_baseline_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_rtk_slip_rtk_slip_is_in_range(int16_t value)
{
    return ((value >= -36000) && (value <= 36000));
}

bool vehicle_rt_sb_rtk_slip_rtk_squat_is_in_range(int16_t value)
{
    return ((value >= -36000) && (value <= 36000));
}

bool vehicle_rt_sb_rtk_slip_rtk_baseline_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_sb_rtk_attitude_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_rtk_attitude_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_rtk_yaw << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_rtk_pitch << 1) & 0x02);
    dst_p[0] |= ((src_p->validity_rtk_roll << 2) & 0x04);
    dst_p[1] |= ((src_p->accuracy_rtk_attitude << 0) & 0xff);
    dst_p[2] |= ((src_p->rtk_attitude_yaw << 0) & 0xff);
    dst_p[3] |= ((src_p->rtk_attitude_yaw >> 8) & 0xff);
    dst_p[4] |= ((src_p->rtk_attitude_pitch << 0) & 0xff);
    dst_p[5] |= ((src_p->rtk_attitude_pitch >> 8) & 0xff);
    dst_p[6] |= ((src_p->rtk_attitude_roll << 0) & 0xff);
    dst_p[7] |= ((src_p->rtk_attitude_roll >> 8) & 0xff);

    return (8);
}

int vehicle_rt_sb_rtk_attitude_decode(
    struct vehicle_rt_sb_rtk_attitude_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_rtk_yaw |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_rtk_pitch |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->validity_rtk_roll |= ((uint8_t)(src_p[0] & 0x04) >> 2);
    dst_p->accuracy_rtk_attitude |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->rtk_attitude_yaw |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->rtk_attitude_yaw |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->rtk_attitude_pitch |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->rtk_attitude_pitch |= ((uint16_t)(src_p[5] & 0xff) << 8);
    dst_p->rtk_attitude_roll |= ((uint16_t)(src_p[6] & 0xff) >> 0);
    dst_p->rtk_attitude_roll |= ((uint16_t)(src_p[7] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_sb_rtk_attitude_validity_rtk_yaw_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_rtk_attitude_validity_rtk_pitch_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_rtk_attitude_validity_rtk_roll_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_rtk_attitude_accuracy_rtk_attitude_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_rtk_attitude_rtk_attitude_yaw_is_in_range(int16_t value)
{
    return ((value >= -36000) && (value <= 36000));
}

bool vehicle_rt_sb_rtk_attitude_rtk_attitude_pitch_is_in_range(int16_t value)
{
    return ((value >= -9000) && (value <= 9000));
}

bool vehicle_rt_sb_rtk_attitude_rtk_attitude_roll_is_in_range(int16_t value)
{
    return ((value >= -9000) && (value <= 9000));
}

ssize_t vehicle_rt_sb_gps_mcycle_lean_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_gps_mcycle_lean_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_gps_lateral_accel << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_gps_mcycle_lean << 1) & 0x02);
    dst_p[1] |= ((src_p->accuracy_gps_lateral_accel << 0) & 0xff);
    dst_p[2] |= ((src_p->gps_lateral_accel << 0) & 0xff);
    dst_p[3] |= ((src_p->gps_lateral_accel >> 8) & 0xff);
    dst_p[4] |= ((src_p->gps_mcycle_lean_angle << 0) & 0xff);
    dst_p[5] |= ((src_p->gps_mcycle_lean_angle >> 8) & 0xff);

    return (8);
}

int vehicle_rt_sb_gps_mcycle_lean_decode(
    struct vehicle_rt_sb_gps_mcycle_lean_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_gps_lateral_accel |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_gps_mcycle_lean |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->accuracy_gps_lateral_accel |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->gps_lateral_accel |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->gps_lateral_accel |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->gps_mcycle_lean_angle |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->gps_mcycle_lean_angle |= ((uint16_t)(src_p[5] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_sb_gps_mcycle_lean_validity_gps_lateral_accel_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gps_mcycle_lean_validity_gps_mcycle_lean_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gps_mcycle_lean_accuracy_gps_lateral_accel_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gps_mcycle_lean_gps_lateral_accel_is_in_range(int16_t value)
{
    return ((value >= -65000) && (value <= 65000));
}

bool vehicle_rt_sb_gps_mcycle_lean_gps_mcycle_lean_angle_is_in_range(int16_t value)
{
    return ((value >= -9000) && (value <= 9000));
}

ssize_t vehicle_rt_sb_gps_status_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_gps_status_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->gps_status << 0) & 0xff);
    dst_p[1] |= ((src_p->firmware_version_major << 0) & 0xff);
    dst_p[2] |= ((src_p->firmware_version_intermediate << 0) & 0xff);
    dst_p[3] |= ((src_p->firmware_version_minor << 0) & 0xff);
    dst_p[4] |= ((src_p->gps_n_sv << 0) & 0xff);
    dst_p[5] |= ((src_p->gps_n_sv_2 << 0) & 0xff);
    dst_p[6] |= ((src_p->gps_n_sv_rtk << 0) & 0xff);
    dst_p[7] |= ((src_p->rtk_status << 0) & 0xff);

    return (8);
}

int vehicle_rt_sb_gps_status_decode(
    struct vehicle_rt_sb_gps_status_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->gps_status |= ((uint8_t)(src_p[0] & 0xff) >> 0);
    dst_p->firmware_version_major |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->firmware_version_intermediate |= ((uint8_t)(src_p[2] & 0xff) >> 0);
    dst_p->firmware_version_minor |= ((uint8_t)(src_p[3] & 0xff) >> 0);
    dst_p->gps_n_sv |= ((uint8_t)(src_p[4] & 0xff) >> 0);
    dst_p->gps_n_sv_2 |= ((uint8_t)(src_p[5] & 0xff) >> 0);
    dst_p->gps_n_sv_rtk |= ((uint8_t)(src_p[6] & 0xff) >> 0);
    dst_p->rtk_status |= ((uint8_t)(src_p[7] & 0xff) >> 0);

    return (0);
}

bool vehicle_rt_sb_gps_status_gps_status_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gps_status_firmware_version_major_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gps_status_firmware_version_intermediate_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gps_status_firmware_version_minor_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gps_status_gps_n_sv_is_in_range(uint8_t value)
{
    return (value <= 16u);
}

bool vehicle_rt_sb_gps_status_gps_n_sv_2_is_in_range(uint8_t value)
{
    return (value <= 16u);
}

bool vehicle_rt_sb_gps_status_gps_n_sv_rtk_is_in_range(uint8_t value)
{
    return (value <= 16u);
}

bool vehicle_rt_sb_gps_status_rtk_status_is_in_range(uint8_t value)
{
    return (true);
}

ssize_t vehicle_rt_sb_gps_pos_ecef_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_gps_pos_ecef_2_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->gps_pos_ecef_y << 0) & 0xff);
    dst_p[1] |= ((src_p->gps_pos_ecef_y >> 8) & 0xff);
    dst_p[2] |= ((src_p->gps_pos_ecef_y >> 16) & 0xff);
    dst_p[3] |= ((src_p->gps_pos_ecef_y >> 24) & 0xff);
    dst_p[4] |= ((src_p->gps_pos_ecef_z << 0) & 0xff);
    dst_p[5] |= ((src_p->gps_pos_ecef_z >> 8) & 0xff);
    dst_p[6] |= ((src_p->gps_pos_ecef_z >> 16) & 0xff);
    dst_p[7] |= ((src_p->gps_pos_ecef_z >> 24) & 0xff);

    return (8);
}

int vehicle_rt_sb_gps_pos_ecef_2_decode(
    struct vehicle_rt_sb_gps_pos_ecef_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->gps_pos_ecef_y |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->gps_pos_ecef_y |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->gps_pos_ecef_y |= ((uint32_t)(src_p[2] & 0xff) << 16);
    dst_p->gps_pos_ecef_y |= ((uint32_t)(src_p[3] & 0xff) << 24);
    dst_p->gps_pos_ecef_z |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->gps_pos_ecef_z |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->gps_pos_ecef_z |= ((uint32_t)(src_p[6] & 0xff) << 16);
    dst_p->gps_pos_ecef_z |= ((uint32_t)(src_p[7] & 0xff) << 24);

    return (0);
}

bool vehicle_rt_sb_gps_pos_ecef_2_gps_pos_ecef_y_is_in_range(int32_t value)
{
    return ((value >= -1000000000) && (value <= 1000000000));
}

bool vehicle_rt_sb_gps_pos_ecef_2_gps_pos_ecef_z_is_in_range(int32_t value)
{
    return ((value >= -1000000000) && (value <= 1000000000));
}

ssize_t vehicle_rt_sb_gps_pos_ecef_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_gps_pos_ecef_1_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_gps_pos_ecef_x << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_gps_pos_ecef_y << 1) & 0x02);
    dst_p[0] |= ((src_p->validity_gps_pos_ecef_z << 2) & 0x04);
    dst_p[1] |= ((src_p->accuracy_gps_pos_ecef_x << 0) & 0xff);
    dst_p[2] |= ((src_p->accuracy_gps_pos_ecef_y << 0) & 0xff);
    dst_p[3] |= ((src_p->accuracy_gps_pos_ecef_z << 0) & 0xff);
    dst_p[4] |= ((src_p->gps_pos_ecef_x << 0) & 0xff);
    dst_p[5] |= ((src_p->gps_pos_ecef_x >> 8) & 0xff);
    dst_p[6] |= ((src_p->gps_pos_ecef_x >> 16) & 0xff);
    dst_p[7] |= ((src_p->gps_pos_ecef_x >> 24) & 0xff);

    return (8);
}

int vehicle_rt_sb_gps_pos_ecef_1_decode(
    struct vehicle_rt_sb_gps_pos_ecef_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_gps_pos_ecef_x |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_gps_pos_ecef_y |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->validity_gps_pos_ecef_z |= ((uint8_t)(src_p[0] & 0x04) >> 2);
    dst_p->accuracy_gps_pos_ecef_x |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->accuracy_gps_pos_ecef_y |= ((uint8_t)(src_p[2] & 0xff) >> 0);
    dst_p->accuracy_gps_pos_ecef_z |= ((uint8_t)(src_p[3] & 0xff) >> 0);
    dst_p->gps_pos_ecef_x |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->gps_pos_ecef_x |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->gps_pos_ecef_x |= ((uint32_t)(src_p[6] & 0xff) << 16);
    dst_p->gps_pos_ecef_x |= ((uint32_t)(src_p[7] & 0xff) << 24);

    return (0);
}

bool vehicle_rt_sb_gps_pos_ecef_1_validity_gps_pos_ecef_x_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gps_pos_ecef_1_validity_gps_pos_ecef_y_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gps_pos_ecef_1_validity_gps_pos_ecef_z_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gps_pos_ecef_1_accuracy_gps_pos_ecef_x_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gps_pos_ecef_1_accuracy_gps_pos_ecef_y_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gps_pos_ecef_1_accuracy_gps_pos_ecef_z_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gps_pos_ecef_1_gps_pos_ecef_x_is_in_range(int32_t value)
{
    return ((value >= -1000000000) && (value <= 1000000000));
}

ssize_t vehicle_rt_sb_gps_pos_llh_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_gps_pos_llh_2_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->gps_pos_llh_longitude << 0) & 0xff);
    dst_p[1] |= ((src_p->gps_pos_llh_longitude >> 8) & 0xff);
    dst_p[2] |= ((src_p->gps_pos_llh_longitude >> 16) & 0xff);
    dst_p[3] |= ((src_p->gps_pos_llh_longitude >> 24) & 0xff);
    dst_p[4] |= ((src_p->gps_pos_llh_altitude << 0) & 0xff);
    dst_p[5] |= ((src_p->gps_pos_llh_altitude >> 8) & 0xff);
    dst_p[6] |= ((src_p->gps_pos_llh_altitude >> 16) & 0xff);
    dst_p[7] |= ((src_p->gps_pos_llh_altitude >> 24) & 0xff);

    return (8);
}

int vehicle_rt_sb_gps_pos_llh_2_decode(
    struct vehicle_rt_sb_gps_pos_llh_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->gps_pos_llh_longitude |= ((uint32_t)(src_p[0] & 0xff) >> 0);
    dst_p->gps_pos_llh_longitude |= ((uint32_t)(src_p[1] & 0xff) << 8);
    dst_p->gps_pos_llh_longitude |= ((uint32_t)(src_p[2] & 0xff) << 16);
    dst_p->gps_pos_llh_longitude |= ((uint32_t)(src_p[3] & 0xff) << 24);
    dst_p->gps_pos_llh_altitude |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->gps_pos_llh_altitude |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->gps_pos_llh_altitude |= ((uint32_t)(src_p[6] & 0xff) << 16);
    dst_p->gps_pos_llh_altitude |= ((uint32_t)(src_p[7] & 0xff) << 24);

    return (0);
}

bool vehicle_rt_sb_gps_pos_llh_2_gps_pos_llh_longitude_is_in_range(int32_t value)
{
    return ((value >= -1800000000) && (value <= 1800000000));
}

bool vehicle_rt_sb_gps_pos_llh_2_gps_pos_llh_altitude_is_in_range(int32_t value)
{
    return ((value >= -1000000) && (value <= 100000000));
}

ssize_t vehicle_rt_sb_gps_pos_llh_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_gps_pos_llh_1_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_gps_pos_llh_latitude << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_gps_pos_llh_longitude << 1) & 0x02);
    dst_p[0] |= ((src_p->validity_gps_pos_llh_altitude << 2) & 0x04);
    dst_p[1] |= ((src_p->accuracy_gps_pos_llh_latitude << 0) & 0xff);
    dst_p[2] |= ((src_p->accuracy_gps_pos_llh_longitude << 0) & 0xff);
    dst_p[3] |= ((src_p->accuracy_gps_pos_llh_altitude << 0) & 0xff);
    dst_p[4] |= ((src_p->gps_pos_llh_latitude << 0) & 0xff);
    dst_p[5] |= ((src_p->gps_pos_llh_latitude >> 8) & 0xff);
    dst_p[6] |= ((src_p->gps_pos_llh_latitude >> 16) & 0xff);
    dst_p[7] |= ((src_p->gps_pos_llh_latitude >> 24) & 0xff);

    return (8);
}

int vehicle_rt_sb_gps_pos_llh_1_decode(
    struct vehicle_rt_sb_gps_pos_llh_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_gps_pos_llh_latitude |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_gps_pos_llh_longitude |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->validity_gps_pos_llh_altitude |= ((uint8_t)(src_p[0] & 0x04) >> 2);
    dst_p->accuracy_gps_pos_llh_latitude |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->accuracy_gps_pos_llh_longitude |= ((uint8_t)(src_p[2] & 0xff) >> 0);
    dst_p->accuracy_gps_pos_llh_altitude |= ((uint8_t)(src_p[3] & 0xff) >> 0);
    dst_p->gps_pos_llh_latitude |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->gps_pos_llh_latitude |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->gps_pos_llh_latitude |= ((uint32_t)(src_p[6] & 0xff) << 16);
    dst_p->gps_pos_llh_latitude |= ((uint32_t)(src_p[7] & 0xff) << 24);

    return (0);
}

bool vehicle_rt_sb_gps_pos_llh_1_validity_gps_pos_llh_latitude_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gps_pos_llh_1_validity_gps_pos_llh_longitude_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gps_pos_llh_1_validity_gps_pos_llh_altitude_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gps_pos_llh_1_accuracy_gps_pos_llh_latitude_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gps_pos_llh_1_accuracy_gps_pos_llh_longitude_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gps_pos_llh_1_accuracy_gps_pos_llh_altitude_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gps_pos_llh_1_gps_pos_llh_latitude_is_in_range(int32_t value)
{
    return ((value >= -900000000) && (value <= 900000000));
}

ssize_t vehicle_rt_sb_gps_heading_gradient_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_gps_heading_gradient_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_gps_heading << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_gps_gradient << 1) & 0x02);
    dst_p[1] |= ((src_p->accuracy_gps_heading << 0) & 0xff);
    dst_p[2] |= ((src_p->gps_heading << 0) & 0xff);
    dst_p[3] |= ((src_p->gps_heading >> 8) & 0xff);
    dst_p[4] |= ((src_p->accuracy_gps_gradient << 0) & 0xff);
    dst_p[5] |= ((src_p->gps_gradient << 0) & 0xff);
    dst_p[6] |= ((src_p->gps_gradient >> 8) & 0xff);

    return (8);
}

int vehicle_rt_sb_gps_heading_gradient_decode(
    struct vehicle_rt_sb_gps_heading_gradient_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_gps_heading |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_gps_gradient |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->accuracy_gps_heading |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->gps_heading |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->gps_heading |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->accuracy_gps_gradient |= ((uint8_t)(src_p[4] & 0xff) >> 0);
    dst_p->gps_gradient |= ((uint16_t)(src_p[5] & 0xff) >> 0);
    dst_p->gps_gradient |= ((uint16_t)(src_p[6] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_sb_gps_heading_gradient_validity_gps_heading_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gps_heading_gradient_validity_gps_gradient_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gps_heading_gradient_accuracy_gps_heading_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gps_heading_gradient_gps_heading_is_in_range(int16_t value)
{
    return ((value >= -18000) && (value <= 18000));
}

bool vehicle_rt_sb_gps_heading_gradient_accuracy_gps_gradient_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gps_heading_gradient_gps_gradient_is_in_range(int16_t value)
{
    return ((value >= -9000) && (value <= 9000));
}

ssize_t vehicle_rt_sb_gps_vel_ecef_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_gps_vel_ecef_2_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_gps_vel_ecef_y << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_gps_vel_ecef_z << 1) & 0x02);
    dst_p[1] |= ((src_p->gps_vel_ecef_y << 0) & 0xff);
    dst_p[2] |= ((src_p->gps_vel_ecef_y >> 8) & 0xff);
    dst_p[3] |= ((src_p->gps_vel_ecef_y >> 16) & 0xff);
    dst_p[4] |= ((src_p->gps_vel_ecef_z << 0) & 0xff);
    dst_p[5] |= ((src_p->gps_vel_ecef_z >> 8) & 0xff);
    dst_p[6] |= ((src_p->gps_vel_ecef_z >> 16) & 0xff);

    return (8);
}

int vehicle_rt_sb_gps_vel_ecef_2_decode(
    struct vehicle_rt_sb_gps_vel_ecef_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_gps_vel_ecef_y |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_gps_vel_ecef_z |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->gps_vel_ecef_y |= ((uint32_t)(src_p[1] & 0xff) >> 0);
    dst_p->gps_vel_ecef_y |= ((uint32_t)(src_p[2] & 0xff) << 8);
    dst_p->gps_vel_ecef_y |= ((uint32_t)(src_p[3] & 0xff) << 16);

    if (dst_p->gps_vel_ecef_y & (1 << 23)) {
        dst_p->gps_vel_ecef_y |= 0xff000000;
    }

    dst_p->gps_vel_ecef_z |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->gps_vel_ecef_z |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->gps_vel_ecef_z |= ((uint32_t)(src_p[6] & 0xff) << 16);

    if (dst_p->gps_vel_ecef_z & (1 << 23)) {
        dst_p->gps_vel_ecef_z |= 0xff000000;
    }

    return (0);
}

bool vehicle_rt_sb_gps_vel_ecef_2_validity_gps_vel_ecef_y_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gps_vel_ecef_2_validity_gps_vel_ecef_z_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gps_vel_ecef_2_gps_vel_ecef_y_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

bool vehicle_rt_sb_gps_vel_ecef_2_gps_vel_ecef_z_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

ssize_t vehicle_rt_sb_gps_vel_ecef_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_gps_vel_ecef_1_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_gps_vel_ecef_x << 0) & 0x01);
    dst_p[1] |= ((src_p->accuracy_gps_vel_ecef_x << 0) & 0xff);
    dst_p[2] |= ((src_p->accuracy_gps_vel_ecef_y << 0) & 0xff);
    dst_p[3] |= ((src_p->accuracy_gps_vel_ecef_z << 0) & 0xff);
    dst_p[4] |= ((src_p->gps_vel_ecef_x << 0) & 0xff);
    dst_p[5] |= ((src_p->gps_vel_ecef_x >> 8) & 0xff);
    dst_p[6] |= ((src_p->gps_vel_ecef_x >> 16) & 0xff);

    return (8);
}

int vehicle_rt_sb_gps_vel_ecef_1_decode(
    struct vehicle_rt_sb_gps_vel_ecef_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_gps_vel_ecef_x |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->accuracy_gps_vel_ecef_x |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->accuracy_gps_vel_ecef_y |= ((uint8_t)(src_p[2] & 0xff) >> 0);
    dst_p->accuracy_gps_vel_ecef_z |= ((uint8_t)(src_p[3] & 0xff) >> 0);
    dst_p->gps_vel_ecef_x |= ((uint32_t)(src_p[4] & 0xff) >> 0);
    dst_p->gps_vel_ecef_x |= ((uint32_t)(src_p[5] & 0xff) << 8);
    dst_p->gps_vel_ecef_x |= ((uint32_t)(src_p[6] & 0xff) << 16);

    if (dst_p->gps_vel_ecef_x & (1 << 23)) {
        dst_p->gps_vel_ecef_x |= 0xff000000;
    }

    return (0);
}

bool vehicle_rt_sb_gps_vel_ecef_1_validity_gps_vel_ecef_x_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gps_vel_ecef_1_accuracy_gps_vel_ecef_x_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gps_vel_ecef_1_accuracy_gps_vel_ecef_y_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gps_vel_ecef_1_accuracy_gps_vel_ecef_z_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gps_vel_ecef_1_gps_vel_ecef_x_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

ssize_t vehicle_rt_sb_gps_vel_ned_2_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_gps_vel_ned_2_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_gps_vel_ned_d << 0) & 0x01);
    dst_p[1] |= ((src_p->accuracy_gps_vel_d << 0) & 0xff);
    dst_p[2] |= ((src_p->gps_vel_ned_d << 0) & 0xff);
    dst_p[3] |= ((src_p->gps_vel_ned_d >> 8) & 0xff);
    dst_p[4] |= ((src_p->gps_vel_ned_d >> 16) & 0xff);

    return (8);
}

int vehicle_rt_sb_gps_vel_ned_2_decode(
    struct vehicle_rt_sb_gps_vel_ned_2_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_gps_vel_ned_d |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->accuracy_gps_vel_d |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->gps_vel_ned_d |= ((uint32_t)(src_p[2] & 0xff) >> 0);
    dst_p->gps_vel_ned_d |= ((uint32_t)(src_p[3] & 0xff) << 8);
    dst_p->gps_vel_ned_d |= ((uint32_t)(src_p[4] & 0xff) << 16);

    if (dst_p->gps_vel_ned_d & (1 << 23)) {
        dst_p->gps_vel_ned_d |= 0xff000000;
    }

    return (0);
}

bool vehicle_rt_sb_gps_vel_ned_2_validity_gps_vel_ned_d_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gps_vel_ned_2_accuracy_gps_vel_d_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gps_vel_ned_2_gps_vel_ned_d_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

ssize_t vehicle_rt_sb_gps_vel_ned_1_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_gps_vel_ned_1_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_gps_vel_ned_n << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_gps_vel_ned_e << 1) & 0x02);
    dst_p[1] |= ((src_p->accuracy_gps_vel_ne << 0) & 0xff);
    dst_p[2] |= ((src_p->gps_vel_ned_n << 0) & 0xff);
    dst_p[3] |= ((src_p->gps_vel_ned_n >> 8) & 0xff);
    dst_p[4] |= ((src_p->gps_vel_ned_n >> 16) & 0xff);
    dst_p[5] |= ((src_p->gps_vel_ned_e << 0) & 0xff);
    dst_p[6] |= ((src_p->gps_vel_ned_e >> 8) & 0xff);
    dst_p[7] |= ((src_p->gps_vel_ned_e >> 16) & 0xff);

    return (8);
}

int vehicle_rt_sb_gps_vel_ned_1_decode(
    struct vehicle_rt_sb_gps_vel_ned_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_gps_vel_ned_n |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_gps_vel_ned_e |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->accuracy_gps_vel_ne |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->gps_vel_ned_n |= ((uint32_t)(src_p[2] & 0xff) >> 0);
    dst_p->gps_vel_ned_n |= ((uint32_t)(src_p[3] & 0xff) << 8);
    dst_p->gps_vel_ned_n |= ((uint32_t)(src_p[4] & 0xff) << 16);

    if (dst_p->gps_vel_ned_n & (1 << 23)) {
        dst_p->gps_vel_ned_n |= 0xff000000;
    }

    dst_p->gps_vel_ned_e |= ((uint32_t)(src_p[5] & 0xff) >> 0);
    dst_p->gps_vel_ned_e |= ((uint32_t)(src_p[6] & 0xff) << 8);
    dst_p->gps_vel_ned_e |= ((uint32_t)(src_p[7] & 0xff) << 16);

    if (dst_p->gps_vel_ned_e & (1 << 23)) {
        dst_p->gps_vel_ned_e |= 0xff000000;
    }

    return (0);
}

bool vehicle_rt_sb_gps_vel_ned_1_validity_gps_vel_ned_n_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gps_vel_ned_1_validity_gps_vel_ned_e_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gps_vel_ned_1_accuracy_gps_vel_ne_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gps_vel_ned_1_gps_vel_ned_n_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

bool vehicle_rt_sb_gps_vel_ned_1_gps_vel_ned_e_is_in_range(int32_t value)
{
    return ((value >= -8380000) && (value <= 8380000));
}

ssize_t vehicle_rt_sb_gps_speed_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_gps_speed_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_gps_speed_2_d << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_gps_speed_3_d << 1) & 0x02);
    dst_p[1] |= ((src_p->accuracy_gps_speed << 0) & 0xff);
    dst_p[2] |= ((src_p->gps_speed_2_d << 0) & 0xff);
    dst_p[3] |= ((src_p->gps_speed_2_d >> 8) & 0xff);
    dst_p[4] |= ((src_p->gps_speed_2_d >> 16) & 0xff);
    dst_p[5] |= ((src_p->gps_speed_3_d << 0) & 0xff);
    dst_p[6] |= ((src_p->gps_speed_3_d >> 8) & 0xff);
    dst_p[7] |= ((src_p->gps_speed_3_d >> 16) & 0xff);

    return (8);
}

int vehicle_rt_sb_gps_speed_decode(
    struct vehicle_rt_sb_gps_speed_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_gps_speed_2_d |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_gps_speed_3_d |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->accuracy_gps_speed |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->gps_speed_2_d |= ((uint32_t)(src_p[2] & 0xff) >> 0);
    dst_p->gps_speed_2_d |= ((uint32_t)(src_p[3] & 0xff) << 8);
    dst_p->gps_speed_2_d |= ((uint32_t)(src_p[4] & 0xff) << 16);
    dst_p->gps_speed_3_d |= ((uint32_t)(src_p[5] & 0xff) >> 0);
    dst_p->gps_speed_3_d |= ((uint32_t)(src_p[6] & 0xff) << 8);
    dst_p->gps_speed_3_d |= ((uint32_t)(src_p[7] & 0xff) << 16);

    return (0);
}

bool vehicle_rt_sb_gps_speed_validity_gps_speed_2_d_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gps_speed_validity_gps_speed_3_d_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gps_speed_accuracy_gps_speed_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gps_speed_gps_speed_2_d_is_in_range(uint32_t value)
{
    return (value <= 16750000u);
}

bool vehicle_rt_sb_gps_speed_gps_speed_3_d_is_in_range(uint32_t value)
{
    return (value <= 16750000u);
}

ssize_t vehicle_rt_sb_gps_time_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_gps_time_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_gps_time << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_gps_week << 1) & 0x02);
    dst_p[1] |= ((src_p->accuracy_gps_time << 0) & 0xff);
    dst_p[2] |= ((src_p->gps_time << 0) & 0xff);
    dst_p[3] |= ((src_p->gps_time >> 8) & 0xff);
    dst_p[4] |= ((src_p->gps_time >> 16) & 0xff);
    dst_p[5] |= ((src_p->gps_time >> 24) & 0xff);
    dst_p[6] |= ((src_p->gps_week << 0) & 0xff);
    dst_p[7] |= ((src_p->gps_week >> 8) & 0xff);

    return (8);
}

int vehicle_rt_sb_gps_time_decode(
    struct vehicle_rt_sb_gps_time_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_gps_time |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_gps_week |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->accuracy_gps_time |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->gps_time |= ((uint32_t)(src_p[2] & 0xff) >> 0);
    dst_p->gps_time |= ((uint32_t)(src_p[3] & 0xff) << 8);
    dst_p->gps_time |= ((uint32_t)(src_p[4] & 0xff) << 16);
    dst_p->gps_time |= ((uint32_t)(src_p[5] & 0xff) << 24);
    dst_p->gps_week |= ((uint16_t)(src_p[6] & 0xff) >> 0);
    dst_p->gps_week |= ((uint16_t)(src_p[7] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_sb_gps_time_validity_gps_time_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gps_time_validity_gps_week_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gps_time_accuracy_gps_time_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gps_time_gps_time_is_in_range(uint32_t value)
{
    return (value <= 604800000u);
}

bool vehicle_rt_sb_gps_time_gps_week_is_in_range(uint16_t value)
{
    return (true);
}

ssize_t vehicle_rt_sb_accel_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_accel_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_accel_longitudinal << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_accel_lateral << 1) & 0x02);
    dst_p[0] |= ((src_p->validity_accel_vertical << 2) & 0x04);
    dst_p[1] |= ((src_p->accuracy_accel << 0) & 0xff);
    dst_p[2] |= ((src_p->accel_longitudinal << 0) & 0xff);
    dst_p[3] |= ((src_p->accel_longitudinal >> 8) & 0xff);
    dst_p[4] |= ((src_p->accel_lateral << 0) & 0xff);
    dst_p[5] |= ((src_p->accel_lateral >> 8) & 0xff);
    dst_p[6] |= ((src_p->accel_vertical << 0) & 0xff);
    dst_p[7] |= ((src_p->accel_vertical >> 8) & 0xff);

    return (8);
}

int vehicle_rt_sb_accel_decode(
    struct vehicle_rt_sb_accel_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_accel_longitudinal |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_accel_lateral |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->validity_accel_vertical |= ((uint8_t)(src_p[0] & 0x04) >> 2);
    dst_p->accuracy_accel |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->accel_longitudinal |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->accel_longitudinal |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->accel_lateral |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->accel_lateral |= ((uint16_t)(src_p[5] & 0xff) << 8);
    dst_p->accel_vertical |= ((uint16_t)(src_p[6] & 0xff) >> 0);
    dst_p->accel_vertical |= ((uint16_t)(src_p[7] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_sb_accel_validity_accel_longitudinal_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_accel_validity_accel_lateral_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_accel_validity_accel_vertical_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_accel_accuracy_accel_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_accel_accel_longitudinal_is_in_range(int16_t value)
{
    return ((value >= -65000) && (value <= 65000));
}

bool vehicle_rt_sb_accel_accel_lateral_is_in_range(int16_t value)
{
    return ((value >= -65000) && (value <= 65000));
}

bool vehicle_rt_sb_accel_accel_vertical_is_in_range(int16_t value)
{
    return ((value >= -65000) && (value <= 65000));
}

ssize_t vehicle_rt_sb_gyro_rates_encode(
    uint8_t *dst_p,
    struct vehicle_rt_sb_gyro_rates_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->validity_gyro_rate_yaw << 0) & 0x01);
    dst_p[0] |= ((src_p->validity_gyro_rate_pitch << 1) & 0x02);
    dst_p[0] |= ((src_p->validity_gyro_rate_roll << 2) & 0x04);
    dst_p[1] |= ((src_p->accuracy_gyro_rates << 0) & 0xff);
    dst_p[2] |= ((src_p->gyro_rate_yaw << 0) & 0xff);
    dst_p[3] |= ((src_p->gyro_rate_yaw >> 8) & 0xff);
    dst_p[4] |= ((src_p->gyro_rate_pitch << 0) & 0xff);
    dst_p[5] |= ((src_p->gyro_rate_pitch >> 8) & 0xff);
    dst_p[6] |= ((src_p->gyro_rate_roll << 0) & 0xff);
    dst_p[7] |= ((src_p->gyro_rate_roll >> 8) & 0xff);

    return (8);
}

int vehicle_rt_sb_gyro_rates_decode(
    struct vehicle_rt_sb_gyro_rates_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->validity_gyro_rate_yaw |= ((uint8_t)(src_p[0] & 0x01) >> 0);
    dst_p->validity_gyro_rate_pitch |= ((uint8_t)(src_p[0] & 0x02) >> 1);
    dst_p->validity_gyro_rate_roll |= ((uint8_t)(src_p[0] & 0x04) >> 2);
    dst_p->accuracy_gyro_rates |= ((uint8_t)(src_p[1] & 0xff) >> 0);
    dst_p->gyro_rate_yaw |= ((uint16_t)(src_p[2] & 0xff) >> 0);
    dst_p->gyro_rate_yaw |= ((uint16_t)(src_p[3] & 0xff) << 8);
    dst_p->gyro_rate_pitch |= ((uint16_t)(src_p[4] & 0xff) >> 0);
    dst_p->gyro_rate_pitch |= ((uint16_t)(src_p[5] & 0xff) << 8);
    dst_p->gyro_rate_roll |= ((uint16_t)(src_p[6] & 0xff) >> 0);
    dst_p->gyro_rate_roll |= ((uint16_t)(src_p[7] & 0xff) << 8);

    return (0);
}

bool vehicle_rt_sb_gyro_rates_validity_gyro_rate_yaw_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gyro_rates_validity_gyro_rate_pitch_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gyro_rates_validity_gyro_rate_roll_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

bool vehicle_rt_sb_gyro_rates_accuracy_gyro_rates_is_in_range(uint8_t value)
{
    return (true);
}

bool vehicle_rt_sb_gyro_rates_gyro_rate_yaw_is_in_range(int16_t value)
{
    return ((value >= -32700) && (value <= 32700));
}

bool vehicle_rt_sb_gyro_rates_gyro_rate_pitch_is_in_range(int16_t value)
{
    return ((value >= -32700) && (value <= 32700));
}

bool vehicle_rt_sb_gyro_rates_gyro_rate_roll_is_in_range(int16_t value)
{
    return ((value >= -32700) && (value <= 32700));
}
